// TESPCDView.cpp : implementation of the CConflictView class
//

#include "stdafx.h"
#include "tespcd.h"
#include "ConflictView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConflictView

IMPLEMENT_DYNCREATE(CConflictView, CView)

BEGIN_MESSAGE_MAP(CConflictView, CView)
	//{{AFX_MSG_MAP(CConflictView)
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_NOTIFY(NM_DBLCLK,ID_CONFGRID, OnDblClick)
	ON_NOTIFY(NM_CHAR,ID_CONFGRID, OnKeyUp)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConflictView construction/destruction

CConflictView::CConflictView()
{
	
}

CConflictView::~CConflictView()
{

}

/////////////////////////////////////////////////////////////////////////////
// CConflictView diagnostics

#ifdef _DEBUG
void CConflictView::AssertValid() const
{
	CView::AssertValid();
}

void CConflictView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CConflictView message handlers

void CConflictView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	if (m_pGridCtrl == NULL)
	{
		// Create the Gridctrl object
		m_pGridCtrl = new CGridCtrl;
		if (!m_pGridCtrl) return;

		// Create the Gridctrl window
		CRect rect;
		GetClientRect(rect);
		m_pGridCtrl->Create(rect, this, ID_CONFGRID);

		// fill it up with stuff
		m_pGridCtrl->SetEditable(FALSE);
		m_pGridCtrl->EnableDragAndDrop(FALSE);

		try {
			m_pGridCtrl->SetRowCount(1);
			m_pGridCtrl->SetColumnCount(6);
			m_pGridCtrl->SetFixedRowCount(1);
			m_pGridCtrl->SetFixedColumnCount(0);
		}
		catch (CMemoryException* e)
		{
			e->ReportError();
			e->Delete();
			return;
		}

		
		GV_ITEM Item;
		Item.mask = GVIF_TEXT|GVIF_FORMAT;
		Item.row = 0;
		Item.nFormat = DT_CENTER|DT_WORDBREAK;
		Item.col = 0;
		m_pGridCtrl->SetColumnWidth(0,50);
		Item.strText = _T("ID");
		m_pGridCtrl->SetItem(&Item);
		Item.col = 1;
		m_pGridCtrl->SetColumnWidth(1,150);
		Item.strText = _T("Conflict");
		m_pGridCtrl->SetItem(&Item);
		Item.col = 2;
		m_pGridCtrl->SetColumnWidth(2,150);
		Item.strText = _T("Name");
		m_pGridCtrl->SetItem(&Item);
		Item.col = 3;
		m_pGridCtrl->SetColumnWidth(3,150);
		Item.strText = _T("Overriding Esp File");
		m_pGridCtrl->SetItem(&Item);
		Item.col = 4;
		m_pGridCtrl->SetColumnWidth(4,150);
		Item.strText = _T("Esp File");
		m_pGridCtrl->SetItem(&Item);
		Item.col = 5;
		m_pGridCtrl->SetColumnWidth(5,100);
		Item.strText = _T("Original File");
		m_pGridCtrl->SetItem(&Item);

		m_pGridCtrl->SetHeaderSort(true);

	}
}

void CConflictView::OnDblClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	
	bool bEsmType = false;
	int nOtherCol;
	CTESEntry *pNewEntry;
	CTESEntry *pOldEntry;
	unsigned char *pNewBuffer;
	int	NewBufferLength;
	unsigned char *pOldBuffer;
	int	OldBufferLength;
	CTESFile *pEspFile;
	CStringArray *SubID, *SubData;
	
	CString cellFilename = m_pGridCtrl->GetItemText(((NM_GRIDVIEW*)pNMHDR)->iRow,((NM_GRIDVIEW*)pNMHDR)->iColumn);
	
	if(((NM_GRIDVIEW*)pNMHDR)->iColumn == 3)
		nOtherCol = 4;
	else if(((NM_GRIDVIEW*)pNMHDR)->iColumn == 4)
		nOtherCol = 3;
	else if(((NM_GRIDVIEW*)pNMHDR)->iColumn == 5)
		nOtherCol = 5;
	else
		nOtherCol = 3;

	CString otherFilename = m_pGridCtrl->GetItemText(((NM_GRIDVIEW*)pNMHDR)->iRow,nOtherCol);
	CString cellID = m_pGridCtrl->GetItemText(((NM_GRIDVIEW*)pNMHDR)->iRow,0);
	CString cellName = m_pGridCtrl->GetItemText(((NM_GRIDVIEW*)pNMHDR)->iRow,2);
	
	CTESPCDDoc* pDoc = GetDocument();
	
	bEsmType = (((NM_GRIDVIEW*)pNMHDR)->iColumn == 5);

	if(pDoc->GetEntry(cellFilename,cellName,cellID,pNewEntry,!bEsmType) &&
	   pDoc->GetEntry(otherFilename,cellName,cellID,pOldEntry,!bEsmType))
	{

		NewBufferLength = pNewEntry->EntryData.GetLength();
		pNewBuffer = (unsigned char*)pNewEntry->EntryData.GetBuffer(0);
		pNewEntry->EntryData.ReleaseBuffer(NewBufferLength);
		
		OldBufferLength = pOldEntry->EntryData.GetLength();
		pOldBuffer = (unsigned char*)pOldEntry->EntryData.GetBuffer(0);
		pOldEntry->EntryData.ReleaseBuffer(OldBufferLength);

		if(((CMainFrame*)AfxGetMainWnd())->FocusPopup(cellFilename + " - " + cellName))
		{
			*pResult = 0;
			return;
		}

		CEntryDlg* pEntryDlg = new CEntryDlg(cellID,cellName,cellFilename);

		pDoc->GetTesFileObj(cellFilename,pEspFile,!bEsmType);
		SubID = new CStringArray(); // Deleted in EntryDlg
		SubData = new CStringArray(); // Deleted in EntryDlg
		pEspFile->ParseEntry(SubID, SubData, *pNewEntry);

		pEntryDlg->SetEsmMode(bEsmType);
		pEntryDlg->SetData(pNewBuffer, NewBufferLength,pOldBuffer,OldBufferLength,
							SubID, SubData);

		if(pEntryDlg->Create(IDD_ENTRYDLG,AfxGetMainWnd()))
		{
			pEntryDlg->SetWindowText(cellFilename + " - " + cellName);
			pEntryDlg->ShowWindow(SW_SHOW);
		}
		else
		{
			delete pEntryDlg;
			delete SubID;
			delete SubData;
		}
	}

	*pResult = 0;
}

void CConflictView::OnKeyUp(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if(((NM_GRIDVIEW*)pNMHDR)->param == VK_DELETE)
	{
		CString cellFilename;
		CString cellID;
		CString cellName;
		CStringArray delArrayFilename, delArrayID, delArrayName;
		int i = 0;

		CCellRange selectedRange = m_pGridCtrl->GetSelectedCellRange();
		int cSelectedRows = selectedRange.GetRowSpan();
		int cSelectedCols = selectedRange.GetColSpan();
		int curRow, curCol;
		BOOL ShowQuestion = true;

		CTESPCDDoc *pDoc = GetDocument();

		curCol = selectedRange.GetMaxCol();
		
		if(cSelectedCols == 1)
		{
			curRow = selectedRange.GetMaxRow();
			for(i = 0;i < cSelectedRows && curRow > 0;i++)
			{
				if(m_pGridCtrl->IsCellSelected(curRow,curCol))
				{
					cellFilename = m_pGridCtrl->GetItemText(curRow,curCol);
					cellID = m_pGridCtrl->GetItemText(curRow,0);
					cellName = m_pGridCtrl->GetItemText(curRow,2);

					((CMainFrame*)AfxGetMainWnd())->ClosePopup(cellFilename + " - " + cellName);

					if(pDoc->RemoveEspEntry(cellFilename, cellID, cellName, ShowQuestion))
					{
						delArrayFilename.Add(cellFilename);
						delArrayID.Add(cellID);
						delArrayName.Add(cellName);

						ShowQuestion = FALSE;
					}
				}

				curRow--;
			}


			for(curRow = 1;curRow < m_pGridCtrl->GetRowCount(); curRow++)
			{
				for(i = 0;i < delArrayFilename.GetSize();i++)
				{
					if(m_pGridCtrl->GetItemText(curRow,0) == delArrayID.GetAt(i) &&
					   m_pGridCtrl->GetItemText(curRow,2) == delArrayName.GetAt(i))
					{
						if(m_pGridCtrl->GetItemText(curRow,3) == delArrayFilename.GetAt(i) ||
							m_pGridCtrl->GetItemText(curRow,4) == delArrayFilename.GetAt(i))
						{
							m_pGridCtrl->DeleteRow(curRow);
							curRow--;
						}
					}
				}
			}	

			m_pGridCtrl->Refresh();
		}
		else
		{
			MessageBox("Unable to Delete", "Please Select One Column at a time.");
		}

		*pResult = 0;
	}
}
