// EntryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TESPCD.h"
#include "EntryDlg.h"
#include "MainFrm.h"
#include "TESPCDDoc.h"
#include "ConflictView.h"
#include "WarningView.h"
#include "EditorView.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEntryDlg dialog

IMPLEMENT_DYNAMIC(CEntryDlg, CDialog)


//CEntryDlg::CEntryDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CEntryDlg::IDD, pParent)
//{
//	//{{AFX_DATA_INIT(CEntryDlg)
//	m_ReadOnlyGrid = TRUE;
//	//}}AFX_DATA_INIT
//
//}

CEntryDlg::CEntryDlg(CString strEntryID, CString strEntryName, CString strFilename)
	: CDialog(CEntryDlg::IDD, NULL)
{
	//{{AFX_DATA_INIT(CEntryDlg)
	m_ReadOnlyGrid = TRUE;
	//}}AFX_DATA_INIT

	m_nNewBufLen = 0;
	m_nOldBufLen = 0;
	m_nDisplayMode = SHOW_GRID;
	m_pHexCtrl = NULL;
	m_pGridCtrl = NULL;
	m_bEsmMode = FALSE;
	m_EntryID = strEntryID;
	m_EntryName = strEntryName;
	m_EspFilename = strFilename;
}

void CEntryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEntryDlg)
	DDX_Control(pDX, IDC_ENTRYDELETE, m_DeleteEntry);
	DDX_Control(pDX, IDC_ENTRYINSERTROW, m_InsertRow);
	DDX_Control(pDX, IDC_ENTRYREADONLY, m_ReadOnlyCtrl);
	DDX_Control(pDX, IDC_ENTRYHEXVIEW, m_ShowHex);
	DDX_Control(pDX, IDC_ENTRYGRIDVIEW, m_ShowGrid);
	DDX_Control(pDX, IDC_ENTRYWRITE, m_WriteEntry);
	DDX_Control(pDX, IDC_ENTRYREMOVEROW, m_RemoveRow);
	DDX_Control(pDX, IDC_ENTRYADDROW, m_AddRow);
	DDX_Check(pDX, IDC_ENTRYREADONLY, m_ReadOnlyGrid);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEntryDlg, CDialog)
	//{{AFX_MSG_MAP(CEntryDlg)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_ENTRYHEXVIEW, OnEntryhexview)
	ON_BN_CLICKED(IDC_ENTRYGRIDVIEW, OnEntrygridview)
	ON_BN_CLICKED(IDC_ENTRYADDROW, OnEntryaddrow)
	ON_BN_CLICKED(IDC_ENTRYINSERTROW, OnEntryinsertrow)
	ON_BN_CLICKED(IDC_ENTRYREMOVEROW, OnEntryremoverow)
	ON_BN_CLICKED(IDC_ENTRYWRITE, OnEntrywrite)
	ON_BN_CLICKED(IDC_ENTRYREADONLY, OnEntryreadonly)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_ENTRYDELETE, OnEntrydelete)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEntryDlg message handlers


BOOL CEntryDlg::Create(UINT nIDTemplate, CWnd* pParentWnd) 
{
	if(m_SubData->GetSize() <= 0)
	{
		return FALSE;
	}
	
	return CDialog::Create(IDD, pParentWnd);
}

BOOL CEntryDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetDisplay(SHOW_GRID); // Initially Shows Grid

	POINT point;

	if(GetCursorPos(&point))
		SetWindowPos(NULL,point.x - 625,point.y,625,250,NULL);
	else
		SetWindowPos(NULL,0,0,625,250,NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEntryDlg::SetData(PUCHAR pNewData,const INT nNewDataLen,
						PUCHAR pOldData,const INT nOldDataLen,
						CStringArray *SubID, CStringArray *SubData,
						CStringArray *OldSubID, CStringArray *OldSubData)
{
	m_pNewBuffer = pNewData;
	m_nNewBufLen = nNewDataLen;
	m_pOldBuffer = pOldData;
	m_nOldBufLen = nOldDataLen;
	m_SubID = SubID;
	m_SubData = SubData;
	m_OldSubID = OldSubID;
	m_OldSubData = OldSubData;
}

// Esm Mode Forces No Editing of the Entries
void CEntryDlg::SetEsmMode(BOOL bMode)
{
	m_bEsmMode = bMode;
}


// Toggle Entry Edit Buttons
void CEntryDlg::SetReadOnlyButtonState(BOOL Enabled)
{
	if(Enabled)
	{
		if(m_pGridCtrl)
			m_pGridCtrl->SetEditable(TRUE);

		m_AddRow.EnableWindow(TRUE);
		m_InsertRow.EnableWindow(TRUE);
		m_RemoveRow.EnableWindow(TRUE);
		m_WriteEntry.EnableWindow(TRUE);
	}
	else
	{
		if(m_pGridCtrl)
			m_pGridCtrl->SetEditable(FALSE);
		
		m_AddRow.EnableWindow(FALSE);
		m_InsertRow.EnableWindow(FALSE);
		m_RemoveRow.EnableWindow(FALSE);
		m_WriteEntry.EnableWindow(FALSE);
	}
}

void CEntryDlg::SetDisplay(_DISPLAY_TYPE nMode)
{

	CRect rect;

	m_nDisplayMode = (_DISPLAY_TYPE) nMode;

	if(m_nDisplayMode == SHOW_HEX)
	{

		if(m_pGridCtrl)
		{	// Grid Already Created, so Hide
			m_pGridCtrl->ShowWindow(SW_HIDE);
		}

		if(m_pHexCtrl)
		{	// Hex Ctrl Already Created, so Show
			m_pHexCtrl->ShowWindow(SW_SHOW);
		}
		else
		{
			m_pHexCtrl = new CPPDumpCtrl;
			if (!m_pHexCtrl) return;

			GetClientRect(rect);
			rect.top = rect.top + 25;
			m_pHexCtrl->Create(rect, this, 100);

			m_pHexCtrl->SetReadOnly();
			
			m_pHexCtrl->SetSpecialCharView('.');

			m_pHexCtrl->SetPointerData(m_nNewBufLen, m_pNewBuffer, m_pOldBuffer, FALSE);

			m_pHexCtrl->SetColor(m_pHexCtrl->PPDUMP_COLOR_DATA_BK, RGB(0,0,0), true);
			m_pHexCtrl->SetColor(m_pHexCtrl->PPDUMP_COLOR_DATA_FG , RGB(200,200,200), true);
			m_pHexCtrl->SetColor(m_pHexCtrl->PPDUMP_COLOR_DATA_CHANGE_FG  , RGB(255,50,50), true);
			m_pHexCtrl->SetColor(m_pHexCtrl->PPDUMP_COLOR_CARET_BK , RGB(0,100,150), true);
			m_pHexCtrl->SetColor(m_pHexCtrl->PPDUMP_COLOR_MOUSE_TRACK , RGB(255,255,255), true);
			m_pHexCtrl->SetColor(m_pHexCtrl->PPDUMP_COLOR_TEXT_HEADER , RGB(0,255,255), true);
			m_pHexCtrl->SetColor(m_pHexCtrl->PPDUMP_COLOR_SEPARATORS , RGB(200,200,200), true);

			m_pHexCtrl->SetStyles(PPDUMP_BAR_ASCII | 
									PPDUMP_BAR_HEX |
									PPDUMP_BAR_ADDRESS |
									PPDUMP_BAR_DEC |
									PPDUMP_FIELD_ADDRESS |
									PPDUMP_FIELD_HEX |
									PPDUMP_FIELD_ASCII |
									PPDUMP_TRACK_MOUSE_MOVE |
									PPDUMP_NAMED_FIELDS |
									PPDUMP_SEPARATOR_LINES |
									PPDUMP_SELECTING_DATA
									,true);
		}
	}
	else if(m_nDisplayMode == SHOW_GRID)
	{
		if(m_pHexCtrl)
		{	// Hex Control Created, so Hide
			m_pHexCtrl->ShowWindow(SW_HIDE);
		}

		if(m_pGridCtrl)
		{	// Grid Control Created, so Show
			m_pGridCtrl->ShowWindow(SW_SHOW);
		}
		else
		{
			m_pGridCtrl = new CGridCtrl;
			if (!m_pGridCtrl) return;

			GetClientRect(rect);
			rect.top = rect.top + 25;
			m_pGridCtrl->Create(rect, this, ID_ENTRYGRID);

			m_pGridCtrl->SetEditable(TRUE);
			m_pGridCtrl->EnableDragAndDrop(FALSE);

			try {
				m_pGridCtrl->SetRowCount(1);
				m_pGridCtrl->SetColumnCount(5);
				m_pGridCtrl->SetFixedRowCount(1);
				m_pGridCtrl->SetFixedColumnCount(1);
			}
			catch (CMemoryException* e)
			{
				e->ReportError();
				e->Delete();
				return;
			}

			SetupGrid(); // Setup and Display all the Grid Data
			SetupGridData();
		}		
	}
}


void CEntryDlg::SetupGrid()
{

	GV_ITEM Item;

	m_pGridCtrl->EnableTitleTips(FALSE);
	m_pGridCtrl->SetRowResize(TRUE);

	Item.mask = GVIF_TEXT|GVIF_FORMAT;
	Item.nFormat = DT_CENTER|DT_WORDBREAK;
	Item.row = 0;

	m_pGridCtrl->SetColumnWidth(0,10);
	Item.col = 1;
	m_pGridCtrl->SetColumnWidth(1,40);
	Item.strText = _T("ID");
	m_pGridCtrl->SetItem(&Item);
	Item.col = 2;
	m_pGridCtrl->SetColumnWidth(2,455);
	Item.strText = _T("Data");
	m_pGridCtrl->SetItem(&Item);
	Item.col = 3;
	m_pGridCtrl->SetColumnWidth(3,40);
	Item.strText = _T("Type");
	m_pGridCtrl->SetItem(&Item);
	Item.col = 4;
	m_pGridCtrl->SetColumnWidth(4,50);
	Item.strText = _T("Bytes");
	m_pGridCtrl->SetItem(&Item);

	m_pGridCtrl->Refresh();
}


void CEntryDlg::SetupGridData()
{
	UCHAR TempChar;
	INT i,j,k;
	INT cEntry;
	INT nItemLen;
	INT nExtractedVal;
	CString strItemBuf, strData, cHexChar;
	GV_ITEM Item;

	Item.mask = GVIF_TEXT|GVIF_FORMAT;
	Item.nFormat = DT_LEFT|DT_VCENTER|DT_WORDBREAK|DT_END_ELLIPSIS|DT_NOPREFIX;

	// Begin Setting up Displayed Data

	cEntry = m_SubID->GetSize();

	m_pGridCtrl->SetRowCount(cEntry+1);

	for (i = cEntry; i > 0; i--)
	{
		Item.row = i;
		Item.col = 1;
		Item.strText = m_SubID->GetAt(i-1);
		m_pGridCtrl->SetItem(&Item);

		
		if((Item.strText == "INDX" || Item.strText == "INTV") &&
		   Item.strText.GetLength() <= 4)
		{	// Integer Mode

			Item.col = 2;
			Item.strText = m_SubData->GetAt(i-1);

			nExtractedVal = 0;
			nItemLen = Item.strText.GetLength();
			
			nExtractedVal = (unsigned char) Item.strText[nItemLen-1];
			for(j = nItemLen - 2; j >= 0;j--)
			{
				nExtractedVal = nExtractedVal << 8;
				nExtractedVal += (unsigned char) Item.strText[j];
			}

			itoa(nExtractedVal,Item.strText.GetBuffer(33),10);//Convert to Ascii
			Item.strText.ReleaseBuffer();
			
			m_pGridCtrl->SetItem(&Item);

			Item.col = 4;
			Item.strText.Format("%d",nItemLen);
			m_pGridCtrl->SetItem(&Item);

			Item.col = 3;
			Item.strText = "Dec";
			m_pGridCtrl->SetItem(&Item);

		}
		else if((Item.strText == "TEXT" || Item.strText == "SCRI" ||
				 Item.strText == "MODL" || Item.strText == "DESC" || 
				 Item.strText == "STRV" || Item.strText == "SCTX" || 
				 Item.strText == "NAME" || Item.strText == "RGNN" ||
				 (Item.strText == "SCVR" && m_EntryID == "INFO") ||
				 (Item.strText == "DATA" && m_EntryID == "LTEX") ||
				 Item.strText.Right(3) == "VFX" ||
				 Item.strText.Right(3) == "TEX" ||
				 Item.strText.Right(3) == "SND" ||
				 Item.strText.Right(3) == "NAM") && 
				 IsBufAscii(&m_SubData->GetAt(i-1)))
		{	// Ascii Mode
			
			Item.col = 2;
			Item.strText = m_SubData->GetAt(i-1);
			nItemLen = Item.strText.GetLength();

			m_pGridCtrl->SetItem(&Item);

			m_pGridCtrl->SetItemData(i,2,Item.strText.GetAt(nItemLen - 1));

			Item.col = 4;
			Item.strText.Format("%d",nItemLen);
			m_pGridCtrl->SetItem(&Item);

			Item.col = 3;
			Item.strText = "Ascii";
			m_pGridCtrl->SetItem(&Item);

		}
		else if(Item.strText == "NPCS" || Item.strText == "RNAM")
		{	// Fixed Mode
		
			Item.col = 2;
			Item.strText = m_SubData->GetAt(i-1);
			nItemLen = Item.strText.GetLength();

			m_pGridCtrl->SetItem(&Item);

			m_pGridCtrl->SetItemData(i,2,nItemLen);

			Item.col = 4;
			Item.strText.Format("%d",nItemLen);
			m_pGridCtrl->SetItem(&Item);

			Item.col = 3;
			Item.strText = "Fixed";
			m_pGridCtrl->SetItem(&Item);
		}
		else if(Item.strText == "NPCO")
		{	// Mixed Mode
			
			Item.col = 2;
			Item.strText = m_SubData->GetAt(i-1);

			nItemLen = Item.strText.GetLength();
			
			// Handle Integer Data
			nExtractedVal = 0;
			nExtractedVal = (unsigned char) Item.strText[3];
			for(j = 2; j >= 0;j--)
			{
				nExtractedVal = nExtractedVal << 8;
				nExtractedVal += (unsigned char) Item.strText[j];
			}

			strItemBuf.Empty();
			itoa(nExtractedVal,strItemBuf.GetBuffer(33),10);//Convert to Ascii
			strItemBuf.ReleaseBuffer();

			// Combine Data
			strItemBuf += " = " + Item.strText.Mid(4);
			Item.strText = strItemBuf;

			m_pGridCtrl->SetItem(&Item);
			m_pGridCtrl->SetItemData(i,2,nItemLen);

			Item.col = 4;
			Item.strText.Format("%d",nItemLen);
			m_pGridCtrl->SetItem(&Item);

			Item.col = 3;
			Item.strText = "Mixed";
			m_pGridCtrl->SetItem(&Item);
		}
		else	
		{	// Default into Hex Mode
		
			Item.col = 2;
			strData = m_SubData->GetAt(i-1);
			
			nItemLen = strData.GetLength();

			strItemBuf.Empty();
			for(j = 0, k = 0; j < strData.GetLength(); j++, k+=2)
			{

				TempChar = strData.GetAt(j);
				cHexChar.Format(_T("%02X"),(UINT) TempChar);
				strItemBuf.Insert(k,cHexChar);
			}
			
			Item.strText = strItemBuf;

			m_pGridCtrl->SetItem(&Item);

			
			Item.col = 4;
			Item.strText.Format("%d",nItemLen);
			m_pGridCtrl->SetItem(&Item);

			Item.col = 3;
			Item.strText = "Hex";
			m_pGridCtrl->SetItem(&Item);
		}

		m_pGridCtrl->AutoSizeRow(i,TRUE);
		if(m_pGridCtrl->GetRowHeight(i) > 100)
			m_pGridCtrl->SetRowHeight(i,100);

		m_pGridCtrl->SetItemState(i,3,GVIS_READONLY);
		m_pGridCtrl->SetItemState(i,4,GVIS_READONLY);
	}

	m_pGridCtrl->Refresh();
}


void CEntryDlg::OnEntryhexview() 
{
	
	SetDisplay(SHOW_HEX);
	m_ShowHex.ShowWindow(SW_HIDE);
	m_ShowGrid.ShowWindow(SW_SHOW);
}

void CEntryDlg::OnEntrygridview() 
{
	
	SetDisplay(SHOW_GRID);
	m_ShowGrid.ShowWindow(SW_HIDE);
	m_ShowHex.ShowWindow(SW_SHOW);
}

void CEntryDlg::OnEntryaddrow() 
{
	INT nRow = m_pGridCtrl->InsertRow("");
	if(nRow >= 0)
		m_pGridCtrl->SetItemData(nRow,2,0);
	m_pGridCtrl->Refresh();
	
}

void CEntryDlg::OnEntryinsertrow() 
{

	CCellRange range = m_pGridCtrl->GetSelectedCellRange();
	INT nRow = m_pGridCtrl->InsertRow("",range.GetMinRow());
	if(nRow >= 0)
		m_pGridCtrl->SetItemData(nRow,2,0);
	m_pGridCtrl->Refresh();
}

void CEntryDlg::OnEntryremoverow() 
{

	CCellRange range = m_pGridCtrl->GetSelectedCellRange();
	m_pGridCtrl->DeleteRow(range.GetMinRow());
	m_pGridCtrl->Refresh();
	
}

void CEntryDlg::OnEntryreadonly() 
{

	UpdateData(TRUE);
	if(m_ReadOnlyGrid)
	{
		m_AddRow.EnableWindow(FALSE);
		m_InsertRow.EnableWindow(FALSE);
		m_RemoveRow.EnableWindow(FALSE);
		m_WriteEntry.EnableWindow(FALSE);
		if(m_pGridCtrl)
			m_pGridCtrl->SetEditable(FALSE);
	}
	else
	{
		m_AddRow.EnableWindow(TRUE);
		m_InsertRow.EnableWindow(TRUE);
		m_RemoveRow.EnableWindow(TRUE);
		m_WriteEntry.EnableWindow(TRUE);
		if(m_pGridCtrl)
			m_pGridCtrl->SetEditable(TRUE);
	}
	
}

void CEntryDlg::OnEntrywrite() 
{
	UCHAR HexVal[16];
	ULONG nItemData;
	INT dataActualLen;
	INT dataReportedLen;
	INT i,row;
	CString strTemp, strFinal, strData, strBuf, strType;

	SetReadOnlyButtonState(FALSE);

	m_SubID->RemoveAll();
	m_SubData->RemoveAll();

	INT cRows = m_pGridCtrl->GetRowCount();
	for(row = 1; row < cRows; row++)
	{
		strFinal.Empty();
		strType = m_pGridCtrl->GetItemText(row,3);
		strType.MakeUpper();

		if(m_pGridCtrl->GetItemText(row,4).GetLength() == 0)
		{
			MessageBox("Length in Bytes Field Invalid","Invalid Data",MB_OK | MB_ICONEXCLAMATION);
			SetReadOnlyButtonState(TRUE);
			return;	
		}

		if(strType == "HEX")
		{	// Handle Hex Type SubEntry
			dataActualLen = m_pGridCtrl->GetItemText(row,2).GetLength();
			dataReportedLen = atoi(m_pGridCtrl->GetItemText(row,4)) * 2;
			strData = m_pGridCtrl->GetItemText(row,2);

			// Check Valid Type
			for(i=0;i < strData.GetLength();i++)
			{
				if(!isxdigit(strData.GetAt(i)))
				{
					MessageBox("Hex Data field not Valid Hexadecimal","Invalid Data",MB_OK | MB_ICONEXCLAMATION);
					SetReadOnlyButtonState(TRUE);
					return;
				}
			}

			// Verify Length
			if(dataActualLen != dataReportedLen)
			{
				strTemp.Format("Hex-Type Data's Length at Row %d has Changed.\n Continue?",row);
				
				if(MessageBox(strTemp, "Length Changed",MB_YESNO | MB_ICONQUESTION)
				   == IDNO)
				{
					// User Requested Exit
					SetReadOnlyButtonState(TRUE);
					return;	
				}
			}

			if(dataActualLen & 0x0001 == 1)
			{
				strTemp.Format("Hex-Type Data's Length at Row %d not Even.\n Fill and Continue?",row);
				
				if(MessageBox(strTemp, "Length not Even",MB_YESNO | MB_ICONQUESTION)
				   == IDYES)
				{
					strData.Insert(strData.GetLength(),"0");
				}
				else
				{	// User Requested Exit
					SetReadOnlyButtonState(TRUE);
					return;	
				}
			}
			// Convert Hex String to Actual Hex Values
			for(i = dataActualLen - 2;i >= 0 ; i-=2)
			{
				strTemp = strData.Mid(i,2);
				sscanf(strTemp,"%02X",&HexVal);
				strFinal.Insert(0,HexVal[0]);
			}
		}
		else if(strType == "DEC")
		{	// Handle Integer Type SubEntry
			dataReportedLen = atoi(m_pGridCtrl->GetItemText(row,4));
			strData = m_pGridCtrl->GetItemText(row,2);

			for(i=0;i < strData.GetLength();i++)
			{
				if(!isdigit(strData.GetAt(i)))
				{
					MessageBox("Decimal Data field not Numeric","Invalid Data",MB_OK | MB_ICONEXCLAMATION);
					SetReadOnlyButtonState(TRUE);
					return;
				}
			}

			nItemData = strtoul(strData,NULL,10);

			if(nItemData > pow(2,dataReportedLen*8) - 1 || strData.GetLength() > 20)
			{	// Check for Integer Data Overflow
	
				ultoa(pow(2,dataReportedLen*8) - 1,strTemp.GetBuffer(33),10);
				strTemp.ReleaseBuffer();
				strTemp.Insert(0,"Integer Value Larger than\n");
				MessageBox(strTemp,"Invalid Data",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}

			strTemp.Empty();
			for(i = 0; i < dataReportedLen; i++)
			{
				strTemp.Insert(i,(unsigned char) nItemData);
				nItemData = nItemData >> 8;
			}
			
			strFinal = strTemp;

		}
		else if(strType == "ASCII")
		{	// Handle Ascii Type Data
			strFinal = m_pGridCtrl->GetItemText(row,2);
			
			if(m_pGridCtrl->GetItemData(row,2) != '\0' && !IsBufAscii(&strFinal))
			{
				strTemp.Format("Ascii Type Data not Valid Ascii at Row %d.",row);

				MessageBox(strTemp,"Invalid Data",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}

			if(m_pGridCtrl->GetItemData(row,2) == '\0')
			{ // Restore Null Character
				strFinal.Insert(strFinal.GetLength(),'\0'); 
			}
		}
		else if(strType == "FIXED")
		{	// Handle Fixed Ascii Type Data
			strFinal = m_pGridCtrl->GetItemText(row,2);
			dataReportedLen = atoi(m_pGridCtrl->GetItemText(row,4));

			strFinal.TrimRight();
			strFinal.TrimLeft();

			if(!IsBufAscii(&strFinal))
			{
				strTemp.Format("Fixed Size Ascii Type Data not Valid Ascii at Row %d.",row);
				MessageBox(strTemp,"Invalid Data",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}

			if(strFinal.GetLength() > dataReportedLen)
			{
				strTemp.Format("Fixed Size Ascii Type Data is Greater than its Max Size at Row %d.",row);
				MessageBox(strTemp,"Invalid Size",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}

			for(i = dataReportedLen - strFinal.GetLength();
				i > 0;i--)
			{
					strFinal += '\0';
			}

			_ASSERT(strFinal.GetLength() == dataReportedLen);
		}
		else if(strType == "MIXED")
		{	// Handle Mixed Integer and Ascii Type Data
			strFinal = m_pGridCtrl->GetItemText(row,2);
			dataReportedLen = atoi(m_pGridCtrl->GetItemText(row,4));
			
			if(m_pGridCtrl->GetItemData(row,2) != dataReportedLen && m_pGridCtrl->GetItemData(row,2) != 0)
			{
				strTemp.Format("Fixed Size Data has Changed Size at Row %d.",row);
				MessageBox(strTemp,"Invalid Size",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}

			if(!IsBufAscii(&strFinal))
			{
				strTemp.Format("Fixed Size Ascii Data not Valid Ascii at Row %d.",row);
				MessageBox(strTemp,"Invalid Data",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}

			if(strFinal.GetLength() > dataReportedLen)
			{
				strTemp.Format("Fixed Size Data is Greater than its Max Size at Row %d.",row);
				MessageBox(strTemp,"Invalid Size",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}

			nItemData = strFinal.Find('=');
			if(nItemData == -1)
			{
				strTemp.Format("Mixed Mode Marker \'=\' not Found at Row %d.",row);
				MessageBox(strTemp,"Invalid Data",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}
			
			strData = strFinal.Left(nItemData);
			strData.TrimLeft();
			strData.TrimRight();
			strBuf = strFinal.Mid(nItemData + 1);
			strBuf.TrimLeft();
			strBuf.TrimRight();

			for(i=0;i < strData.GetLength();i++)
			{
				if(!isdigit(strData.GetAt(i)) && strData.GetAt(i) != '-')
				{
					strTemp.Format("Decimal Data not Numeric at Row %d.",row);
					MessageBox(strTemp,"Invalid Data",MB_OK | MB_ICONEXCLAMATION);
					SetReadOnlyButtonState(TRUE);
					return;
				}
			}

			if(!IsBufAscii(&strBuf))
			{
				strTemp.Format("Fixed Size Ascii Data is not Valid Ascii at Row %d.",row);
				MessageBox(strTemp,"Invalid Data",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}

			nItemData = strtoul(strData,NULL,10);

			if(nItemData > pow(2,4*8) - 1 || strData.GetLength() > 10)
			{	// Check for Integer Data Overflow
	
				ultoa(pow(2,4*8) - 1,strTemp.GetBuffer(33),10);
				strTemp.ReleaseBuffer();
				strTemp.Insert(0,"Decimal Value Larger than\n");
				MessageBox(strTemp,"Invalid Data",MB_OK | MB_ICONEXCLAMATION);
				SetReadOnlyButtonState(TRUE);
				return;
			}

			strTemp.Empty();
			for(i = 0; i < 4; i++)
			{
				strTemp.Insert(i,(unsigned char) nItemData);
				nItemData = nItemData >> 8;
			}
			
			strFinal = strTemp + strBuf;

			for(i = dataReportedLen - strFinal.GetLength();
				i > 0;i--)
			{
					strFinal += '\0';
			}

			_ASSERT(strFinal.GetLength() == dataReportedLen);

		}
		else
		{
			MessageBox("Invalid Type Field.","Invalid Data",MB_OK | MB_ICONEXCLAMATION);
			SetReadOnlyButtonState(TRUE);
			return;
		}

		// Add New Entry SubData to List
		m_SubData->Add(strFinal);

		// Verify ID Length
		if(m_pGridCtrl->GetItemText(row,1).GetLength() != 4)
		{
			MessageBox("ID Length Invalid.","Invalid Data",MB_OK | MB_ICONEXCLAMATION);
			SetReadOnlyButtonState(TRUE);	
			return;
		}
		m_SubID->Add(m_pGridCtrl->GetItemText(row,1));
	}

	CMainFrame* pFrm = (CMainFrame*) GetParentFrame();
	CTESPCDDoc* pDoc = (CTESPCDDoc*) pFrm->GetActiveDocument();

	pDoc->UpdateEspEntry(m_SubID,m_SubData, m_EntryID, m_EntryName, m_EspFilename);

	SetReadOnlyButtonState(TRUE);
}


void CEntryDlg::OnEntrydelete() 
{
	
	CMainFrame* pFrm = (CMainFrame*) GetParentFrame();
	CTESPCDDoc* pDoc = (CTESPCDDoc*) pFrm->GetActiveDocument();

	if(pDoc->RemoveEspEntry(m_EspFilename,m_EntryID,m_EntryName))
	{
		CWarningView* pWView = (CWarningView*) pDoc->GetView("CWarningView");
		CConflictView* pCView = (CConflictView*) pDoc->GetView("CConflictView");
		CEditorView* pEView = (CEditorView*) pDoc->GetView("CEditorView");

		// Remove All Rows with this Entry from all Panels 
		if(pCView)
		{
			INT cCGrid = pCView->m_pGridCtrl->GetRowCount();
			for(INT nRow = 1;nRow < cCGrid;nRow++)
			{		
				if(m_pGridCtrl->GetItemText(nRow,0) == m_EntryID &&
				   m_pGridCtrl->GetItemText(nRow,2) == m_EntryName)
				{
					if(m_pGridCtrl->GetItemText(nRow,3) == m_EspFilename ||
						m_pGridCtrl->GetItemText(nRow,4) == m_EspFilename)
					{
						m_pGridCtrl->DeleteRow(nRow);
						nRow--;
					}
				}
			}
			pCView->m_pGridCtrl->Refresh();
		}

		if(pWView)
		{
			INT cWGrid = pWView->m_pGridCtrl->GetRowCount();
			for(INT nRow = 1;nRow < cWGrid;nRow++)
			{	

				if(pWView->m_pGridCtrl->GetItemText(nRow,2) == m_EntryName)
				{
					if(pWView->m_pGridCtrl->GetItemText(nRow,0) == m_EntryID &&
						pWView->m_pGridCtrl->GetItemText(nRow,3) == m_EspFilename)
					{
						pWView->m_pGridCtrl->DeleteRow(nRow);
						break;
					}
				}
			}
			pWView->m_pGridCtrl->Refresh();
		}

		if(pEView)
		{
			INT cEGrid = pEView->m_pGridCtrl->GetRowCount();
			for(INT nRow = 1;nRow < cEGrid;nRow++)
			{	
				if(pEView->m_pGridCtrl->GetItemText(nRow,2) == m_EntryName)
				{
					if(pEView->m_pGridCtrl->GetItemText(nRow,0) == m_EntryID &&
						pEView->m_pGridCtrl->GetItemText(nRow,3) == m_EspFilename)
					{
						pEView->m_pGridCtrl->DeleteRow(nRow);
						break;
					}
				}
			}
			pEView->m_pGridCtrl->Refresh();
		}

		OnClose();
	}
}


void CEntryDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);

	if(bShow)
	{
		switch(m_nDisplayMode)
		{
		case SHOW_GRID:
			m_ShowGrid.ShowWindow(SW_HIDE);
			m_ShowHex.ShowWindow(SW_SHOW);
			break;
		case SHOW_HEX:
			m_ShowHex.ShowWindow(SW_HIDE);
			m_ShowGrid.ShowWindow(SW_SHOW);
			break;
		}

		CRect thisrect, buttonrect;
		
		GetClientRect(thisrect);

		m_ReadOnlyCtrl.GetClientRect(buttonrect);

		m_ReadOnlyCtrl.SetWindowPos(NULL,thisrect.right - 10 - buttonrect.Width(),	5,
				buttonrect.Width(),buttonrect.Height(),NULL);

		if(m_bEsmMode)
		{	// Force No Saving of Changes
			m_ReadOnlyCtrl.ShowWindow(SW_HIDE);
			m_AddRow.ShowWindow(SW_HIDE);
			m_InsertRow.ShowWindow(SW_HIDE);
			m_RemoveRow.ShowWindow(SW_HIDE);
			m_WriteEntry.ShowWindow(SW_HIDE);
			m_DeleteEntry.ShowWindow(SW_HIDE);
			m_AddRow.EnableWindow(FALSE);
			m_InsertRow.EnableWindow(FALSE);
			m_RemoveRow.EnableWindow(FALSE);
			m_WriteEntry.EnableWindow(FALSE);
			m_DeleteEntry.EnableWindow(FALSE);
			if(m_pGridCtrl)
				m_pGridCtrl->SetEditable(TRUE);
		}
		else
		{
			UpdateData(TRUE);
			if(m_ReadOnlyGrid)
			{
				SetReadOnlyButtonState(FALSE);
			}
			else
			{
				SetReadOnlyButtonState(TRUE);
			}
		}


	}
}

void CEntryDlg::OnSize(UINT nType, INT cx, INT cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	CRect rect;
	GetClientRect(rect);
	rect.top = rect.top + 25;

	if (m_pGridCtrl->GetSafeHwnd())
	{
		m_pGridCtrl->MoveWindow(rect);
	}	

	if (m_pHexCtrl->GetSafeHwnd())
	{
		m_pHexCtrl->MoveWindow(rect);
	}	

	if(m_ReadOnlyCtrl)
	{
		CRect thisrect, buttonrect;
		INT x;
		
		GetClientRect(thisrect);

		m_ReadOnlyCtrl.GetClientRect(buttonrect);
		x = thisrect.right - 10 - buttonrect.Width();
		if(x < 525)
			x = 525;
		m_ReadOnlyCtrl.SetWindowPos(NULL,x,	5,
				buttonrect.Width(),buttonrect.Height(),NULL);

	}

}

LRESULT CEntryDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if(message == UDM_CHECK)
	{	// Message Sent When New Operation is Triggered
		DestroyWindow();
		return 0;
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}

void CEntryDlg::OnClose() 
{

	CDialog::OnClose();

	DestroyWindow();
}

void CEntryDlg::OnCancel() 
{
	
	CDialog::OnCancel();

	DestroyWindow();
}

void CEntryDlg::OnOK()
{
	CDialog::OnOK();

	DestroyWindow();
}

// Handle Cleanup of Buffers
void CEntryDlg::PostNcDestroy() 
{	
	if (m_pHexCtrl)
		delete m_pHexCtrl;

	if (m_pGridCtrl)
		delete m_pGridCtrl;

	if(m_SubID)
		delete m_SubID;
	
	if(m_SubData)
		delete m_SubData;

	CDialog::PostNcDestroy();
	delete this;
}

// Helper Function to Verify CString Buffer is Valid Ascii
BOOL CEntryDlg::IsBufAscii(CString *pstrBuffer)
{
	if(pstrBuffer->GetLength() == 0)
		return false;
	
	INT cBuff = pstrBuffer->GetLength();

	for(INT i = 0; i < cBuff - 1; i++)
	{
		if( !((((unsigned char)pstrBuffer->GetAt(i)) >= 0x20 &&
			   ((unsigned char)pstrBuffer->GetAt(i)) <= 0xFE) ||
			   pstrBuffer->GetAt(i) == '\n' || 
			   pstrBuffer->GetAt(i) == '\r' ||
		       pstrBuffer->GetAt(i) == '\t'))
		{
			return false;
		}
	}

	i = 0;
	if(cBuff == 1 &&
		!((((unsigned char)pstrBuffer->GetAt(i)) >= 0x20 &&
		   ((unsigned char)pstrBuffer->GetAt(i)) <= 0x7E) ||
			   pstrBuffer->GetAt(i) == '\n' || 
			   pstrBuffer->GetAt(i) == '\r' ||
		       pstrBuffer->GetAt(i) == '\t' ||
			   pstrBuffer->GetAt(i) == '\0'))
	{
		return false;
	}
	
	
	return true;
}