#if !defined(AFX_HEXDLG_H__0B4998C5_28AD_4DB8_B4B4_A41A26FB3222__INCLUDED_)
#define AFX_HEXDLG_H__0B4998C5_28AD_4DB8_B4B4_A41A26FB3222__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EntryDlg.h : header file
//

#include ".\PPDumpCtrl\PPDumpCtrl.h"
#include ".\GridCtrl\GridCtrl.h"
/////////////////////////////////////////////////////////////////////////////
// CEntryDlg dialog

class CEntryDlg : public CDialog
{
// Construction
public:
	DECLARE_DYNAMIC(CEntryDlg);

	//CEntryDlg(CWnd* pParent = NULL);   // standard constructor
	CEntryDlg(CString strEntryID, CString strEntryName, CString strFilename);

	void SetEsmMode(BOOL bMode);

	void SetData(PUCHAR pNewData,const INT nNewDataLen,
				 PUCHAR pOldData,const INT nOldDataLen,
				 CStringArray *SubID, CStringArray *SubData,
				 CStringArray *OldSubID = NULL, CStringArray *OldSubData = NULL);

// Dialog Data
	//{{AFX_DATA(CEntryDlg)
	enum { IDD = IDD_ENTRYDLG };
	CButton	m_DeleteEntry;
	CButton	m_InsertRow;
	CButton	m_ReadOnlyCtrl;
	CButton	m_ShowHex;
	CButton	m_ShowGrid;
	CButton	m_WriteEntry;
	CButton	m_RemoveRow;
	CButton	m_AddRow;
	BOOL	m_ReadOnlyGrid;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEntryDlg)
	public:
	virtual BOOL Create(UINT nIDTemplate, CWnd* pParentWnd = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:
	
	enum _DISPLAY_TYPE
	{
		SHOW_GRID,
		SHOW_HEX
	} m_nDisplayMode;

	// Set Current Display to enum Type
	void SetDisplay(_DISPLAY_TYPE nMode);
	
	// Setup Grid's Fixed Rows, Column Sizes, and Formats
	void SetupGrid();
	// Parse and Insert Data into Grid
	void SetupGridData();

	// Sets the State of the Data Modification Buttons. 
	void SetReadOnlyButtonState(BOOL Enabled);

	// CString Buffer Helper Function - TODO: Move out of class
	BOOL IsBufAscii(CString *strBuffer);

	// Buffer that contains raw Data for Hex Display
	unsigned char* m_pNewBuffer;
	int m_nNewBufLen;

	// Buffer that contains conflict raw Data for Hex Display, 
	// Used for -Is Different- Highlighting.
	unsigned char* m_pOldBuffer;
	int m_nOldBufLen;

	// Specifics of the Entry this particular Dialog is displaying
	CString m_EntryID, m_EntryName, m_EspFilename;

	// Parsed Entry Data for use with Grid View
	CStringArray *m_SubID;
	CStringArray *m_SubData;

	// Parsed Old Entry Data for use with Grid View Highlighting
	CStringArray *m_OldSubID;
	CStringArray *m_OldSubData;

	// Hex Display Control
	CPPDumpCtrl *m_pHexCtrl;
	// Grid Display Control
	CGridCtrl *m_pGridCtrl;

	// If Set then Data Modification Buttons are hidden
	BOOL m_bEsmMode;

	// Generated message map functions
	//{{AFX_MSG(CEntryDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnEntryhexview();
	afx_msg void OnEntrygridview();
	afx_msg void OnEntryaddrow();
	afx_msg void OnEntryinsertrow();
	afx_msg void OnEntryremoverow();
	afx_msg void OnEntrywrite();
	afx_msg void OnEntryreadonly();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnEntrydelete();
	afx_msg void OnClose();
	virtual void OnCancel();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HEXDLG_H__0B4998C5_28AD_4DB8_B4B4_A41A26FB3222__INCLUDED_)
