// FindObject.cpp : implementation file
//

#include "stdafx.h"
#include "tespcd.h"
#include "FindObject.h"
#include "MainFrm.h"
#include "TESPCDDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindObject dialog


CFindObject::CFindObject(CWnd* pParent /*=NULL*/)
	: CDialog(CFindObject::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindObject)
	m_bMatchcase = FALSE;
	m_bMatchword = FALSE;
	m_strObjName = _T("");
	m_bLookdata = TRUE;
	m_iSearchMode = -1;
	//}}AFX_DATA_INIT
}


void CFindObject::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindObject)
	DDX_Control(pDX, IDC_FO_OBJNAME, m_cmbObjName);
	DDX_Check(pDX, IDC_FO_MATCHCASE, m_bMatchcase);
	DDX_Check(pDX, IDC_FO_MATCHWORD, m_bMatchword);
	DDX_CBString(pDX, IDC_FO_OBJNAME, m_strObjName);
	DDX_Check(pDX, IDC_FO_LOOKDATA, m_bLookdata);
	DDX_Radio(pDX, IDC_ESPMODE, m_iSearchMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindObject, CDialog)
	//{{AFX_MSG_MAP(CFindObject)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindObject message handlers

BOOL CFindObject::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CMainFrame * pFrm = (CMainFrame *) GetParentFrame();
	CTESPCDDoc * pDoc = (CTESPCDDoc *) pFrm->GetActiveDocument();

	for(int i = 0;i < pDoc->m_cFindHistory;i++)
	{
		m_cmbObjName.AddString(pDoc->m_strFind[i]);
	}

	m_iSearchMode = 0;
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFindObject::OnOK() 
{
	CString strTemp;
	int iFindR = CB_ERR;

	CMainFrame * pFrm = (CMainFrame *) GetParentFrame();
	CTESPCDDoc * pDoc = (CTESPCDDoc *) pFrm->GetActiveDocument();

	UpdateData(TRUE);

	for(int i = 0;i < m_cmbObjName.GetCount();i++)
	{
		m_cmbObjName.GetLBText(i,strTemp);
		if(strTemp == m_strObjName)
		{
			iFindR = i;
			break;
		}
	}

	if(iFindR == CB_ERR)
	{
		for(int i = pDoc->m_cFindHistory - 1;i > 0;i--)
		{
			pDoc->m_strFind[i] = pDoc->m_strFind[i-1];
		}
		pDoc->m_strFind[0] = m_strObjName;
	}
	else
	{
		strTemp = pDoc->m_strFind[iFindR];

		for(int i = iFindR;i > 0;i--)
		{
			pDoc->m_strFind[i] = pDoc->m_strFind[i-1];
		}

		pDoc->m_strFind[0] = strTemp;

	}
	
	CDialog::OnOK();
}
