// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__0A914D31_9D0E_477D_8A2A_604F130F42FE__INCLUDED_)
#define AFX_MAINFRM_H__0A914D31_9D0E_477D_8A2A_604F130F42FE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ProgressBar.h"
#include "SplitterWndEx.h"

// BIT Fields for m_bfPanelsShown
#define PANEL_CONFLICT	0x01
#define PANEL_WARNING	0x02
#define PANEL_EDITOR	0x04
#define PANEL_ALL		0x07
#define PANEL_NONE		0x00

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
protected:
	// Splitter Windows for all Panes
	CSplitterWndEx *m_pWndSplitter[3];
	UCHAR m_cSplitters;	// Splitter Window Count
	
	UCHAR m_bfPanelsShown; // BIT Field to Manage Shown Panels

public:

	// Close all Application Owned Popups
	BOOL ClosePopupWindows();

	// Close a specific Popup Window
	BOOL ClosePopup(const CString strTitle);

	// Set Focus to a specific Popup Window
	BOOL FocusPopup(const CString strTitle);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CReBar      m_wndReBar;
	//CDialogBar	m_wndDlgBar;
	CProgressBar m_wndProgressBar;
	BOOL m_bInitShow;	// True if Window Initialized

// Generated message map functions
protected:
	void InitWindow();	// Called on Initial ShowWindow
	void OnStepBar(CString*, int);	// Handle Progress Bar Changes
	bool PeekAndPump();	// Force Translate and Dispatch Messages
	void OnPanelOn(int row);	// Turns Splitter Panel On, If row = 0 Turns All On
	void OnPanelOff(int row);	// Turns Splitter Panel Off, If row = 0 Turns All Off

	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnAppExit();
	afx_msg void OnEdtpane();
	afx_msg void OnCnfpane();
	afx_msg void OnWrnpane();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnOperationsViewfiledata();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__0A914D31_9D0E_477D_8A2A_604F130F42FE__INCLUDED_)
