// PPageOP.cpp : implementation file
//

#include "stdafx.h"
#include "tespcd.h"
#include "PPageOP.h"
#include "TESOperations.h"
#include "MainFrm.h"
#include "TESPCDDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPPageOP property page

IMPLEMENT_DYNCREATE(CPPageOP, CPropertyPage)

CPPageOP::CPPageOP() : CPropertyPage(CPPageOP::IDD)
{
	//{{AFX_DATA_INIT(CPPageOP)
	m_bCheckConflicts = FALSE;
	m_bCheckDeleted = FALSE;
	m_bCheckUnclean = FALSE;
	m_bLoadEsms = FALSE;
	m_bExtCellData = FALSE;
	m_bExtInfoData = FALSE;
	m_bExtLandData = FALSE;
	m_bExtPgrdData = FALSE;
	m_bUncleanINFO = FALSE;
	//}}AFX_DATA_INIT
}

CPPageOP::~CPPageOP()
{
}

void CPPageOP::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPPageOP)
	DDX_Check(pDX, IDC_CHECKCONFLICTS, m_bCheckConflicts);
	DDX_Check(pDX, IDC_CHECKDELETED, m_bCheckDeleted);
	DDX_Check(pDX, IDC_CHECKUNCLEAN, m_bCheckUnclean);
	DDX_Check(pDX, IDC_LOADESMS, m_bLoadEsms);
	DDX_Check(pDX, IDC_EXTCELLDATA, m_bExtCellData);
	DDX_Check(pDX, IDC_EXTINFODATA, m_bExtInfoData);
	DDX_Check(pDX, IDC_EXTLANDDATA, m_bExtLandData);
	DDX_Check(pDX, IDC_EXTPGRDDATA, m_bExtPgrdData);
	DDX_Check(pDX, IDC_UNCLEANINFO, m_bUncleanINFO);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPPageOP, CPropertyPage)
	//{{AFX_MSG_MAP(CPPageOP)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPPageOP message handlers

void CPPageOP::OnOK() 
{
	UpdateData(TRUE);
	
	CTESPCDDoc* pDoc = (CTESPCDDoc*)((CMainFrame*)AfxGetMainWnd())->GetActiveDocument();

	if(m_bCheckConflicts)
		pDoc->m_DefOpFlags |= CHECK_CONFLICTS;
	else
		pDoc->m_DefOpFlags &= ~CHECK_CONFLICTS; 

	if(m_bCheckUnclean)
		pDoc->m_DefOpFlags |= CHECK_UNCLEAN;
	else
		pDoc->m_DefOpFlags &= ~CHECK_UNCLEAN;  

	if(m_bCheckDeleted)
		pDoc->m_DefOpFlags |= CHECK_DELETIONS;
	else
		pDoc->m_DefOpFlags &= ~CHECK_DELETIONS;

	pDoc->SetLoadEsms(m_bLoadEsms);

	pDoc->m_ExtractOpt.bIncCELL = m_bExtCellData;
	pDoc->m_ExtractOpt.bIncINFO = m_bExtInfoData;
	pDoc->m_ExtractOpt.bIncLAND = m_bExtLandData;
	pDoc->m_ExtractOpt.bIncPGRD = m_bExtPgrdData;

	pDoc->m_UncleanCheckTypes.INFO = m_bUncleanINFO;

	CPropertyPage::OnOK();
}

BOOL CPPageOP::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CTESPCDDoc* pDoc = (CTESPCDDoc*)((CMainFrame*)AfxGetMainWnd())->GetActiveDocument();

	if(pDoc->m_DefOpFlags & CHECK_CONFLICTS)
		m_bCheckConflicts = TRUE;
	else
		m_bCheckConflicts = FALSE; 

	if(pDoc->m_DefOpFlags & CHECK_UNCLEAN)
		m_bCheckUnclean = TRUE;
	else
		m_bCheckUnclean = FALSE; 

	if(pDoc->m_DefOpFlags & CHECK_DELETIONS)
		m_bCheckDeleted = TRUE;
	else
		m_bCheckDeleted = FALSE; 

	this->m_bLoadEsms = pDoc->GetLoadEsms();

	m_bExtCellData = pDoc->m_ExtractOpt.bIncCELL;
	m_bExtInfoData = pDoc->m_ExtractOpt.bIncINFO;
	m_bExtLandData = pDoc->m_ExtractOpt.bIncLAND;
	m_bExtPgrdData = pDoc->m_ExtractOpt.bIncPGRD;

	m_bUncleanINFO = pDoc->m_UncleanCheckTypes.INFO;

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPPageOP::OnCancel() 
{

	UpdateData(FALSE);

	CPropertyPage::OnCancel();
}
