// RepairTool.cpp : implementation file
//

#include "stdafx.h"
#include "tespcd.h"
#include "RepairToolDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRepairToolDlg dialog


CRepairToolDlg::CRepairToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRepairToolDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRepairToolDlg)
	m_strRepairEsp = _T("");
	//}}AFX_DATA_INIT
}


void CRepairToolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRepairToolDlg)
	DDX_Control(pDX, IDC_TOPICLIST, m_EspListBox);
	DDX_Text(pDX, IDC_REPAIRESP, m_strRepairEsp);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRepairToolDlg, CDialog)
	//{{AFX_MSG_MAP(CRepairToolDlg)
	ON_BN_CLICKED(IDC_ADDACTIVE, OnAddactive)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_BROWSEESPS, OnBrowseesps)
	ON_BN_CLICKED(IDC_CLEARLIST, OnClearlist)
	ON_BN_CLICKED(IDC_CREATENEW, OnCreatenew)
	ON_BN_CLICKED(IDC_DELETEEXIST, OnDeleteexist)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_LISTCONTEXTREMOVE, OnListcontextremove)
	ON_COMMAND(ID_LISTCONTEXTADD, OnListcontextadd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRepairToolDlg message handlers

BOOL CRepairToolDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRepairToolDlg::OnAddactive() 
{
	if(m_pDoc->m_strBasePath == "")
	{
	}
	
	CString strIniName;
	CString strPluginName;
	CString strTemp;
	int bPlugins = true;

	for(int i = 0;bPlugins;i++)
	{
		strIniName.Format("GameFile%d",i);

		bPlugins = GetPrivateProfileString("Game Files",strIniName,"",strPluginName.GetBuffer(MAX_PATH),
				MAX_PATH,m_pDoc->m_strBasePath + _T("\\Morrowind.ini"));
	
		strPluginName.ReleaseBuffer();

		strTemp = strPluginName.Right(3);
		strTemp.MakeUpper();

		if(strPluginName != "" && strTemp == "ESP")
		{
			if(!m_EspFileList.Find(strPluginName,NULL) && 
			   !(strPluginName == m_strDialogEspFile && m_pDoc->m_strDataFilesPath == m_strDialogEspPath))
			{
				m_EspFileList.AddHead(strPluginName);
				m_EspPathList.AddHead(m_pDoc->m_strDataFilesPath);
			}
		}

	}

	int length, count;
	POSITION pos;

	m_EspListBox.ResetContent();
	length = m_EspFileList.GetCount();
	
	pos = m_EspFileList.GetHeadPosition();
	for(count = 0;count < length;count++)
	{
		m_EspListBox.AddString(m_EspFileList.GetNext(pos));
	}
	
}

void CRepairToolDlg::OnBrowse() 
{
	OPENFILENAME vOpenFile;
	CString strTempFile;
	CString strDefExt = _T("esp");
	char strFilter[] = _T("Plugin Files (*.esp)\0*.esp\0All Files (*.*)\0*.*\0\0");

	vOpenFile.lStructSize = sizeof(vOpenFile); //OPENFILENAME_SIZE_VERSION_400;
	vOpenFile.hwndOwner = AfxGetMainWnd()->GetSafeHwnd();
	vOpenFile.lpstrFilter = strFilter;
	vOpenFile.lpstrCustomFilter = NULL;
	vOpenFile.nFilterIndex = 1;
	vOpenFile.lpstrFile = strTempFile.GetBuffer(OPENDIALOG_BUFFERSIZE);
	vOpenFile.nMaxFile = OPENDIALOG_BUFFERSIZE;
	vOpenFile.lpstrFileTitle = NULL;
	vOpenFile.lpstrInitialDir = m_pDoc->m_strDataFilesPath;
	vOpenFile.lpstrTitle = _T("Select Master Plugin to Check Against\0");
	vOpenFile.Flags = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST;
	vOpenFile.lpstrDefExt = strDefExt.GetBuffer(4);

	if(!GetOpenFileName(&vOpenFile))
		return;

	strTempFile.ReleaseBuffer();

	if(m_EspFileList.Find(strTempFile.Mid(vOpenFile.nFileOffset)) != NULL)
	{
		AfxGetMainWnd()->MessageBox("Please Remove from Esp List","Already Loaded",MB_OK);
		return;
	}
	
	m_strDialogEspPath = strTempFile.Left(vOpenFile.nFileOffset);
	m_strDialogEspFile = strTempFile.Mid(vOpenFile.nFileOffset);

	if(m_strDialogEspPath.Right(1) != "\\")
	{
		m_strDialogEspPath += _T("\\");
	}

	m_strRepairEsp = m_strDialogEspFile;
	UpdateData(FALSE);
}

void CRepairToolDlg::OnBrowseesps() 
{
	int count = 0;
	int sublength = 0;
	int length = 0;
	POSITION pos;
	CString strTempPath;

	OPENFILENAME vOpenFile;
	CString strTempFile;
	CString strDefExt = _T("esp");
	char strFilter[] = _T("Plugin Files (*.esp)\0*.esp\0All Files (*.*)\0*.*\0\0");

	vOpenFile.lStructSize = sizeof(vOpenFile); //OPENFILENAME_SIZE_VERSION_400;
	vOpenFile.hwndOwner = AfxGetMainWnd()->GetSafeHwnd();
	vOpenFile.lpstrFilter = strFilter;
	vOpenFile.lpstrCustomFilter = NULL;
	vOpenFile.nFilterIndex = 1;
	vOpenFile.lpstrFile = strTempFile.GetBuffer(OPENDIALOG_BUFFERSIZE);
	vOpenFile.nMaxFile = OPENDIALOG_BUFFERSIZE;
	vOpenFile.lpstrFileTitle = NULL;
	vOpenFile.lpstrInitialDir = m_pDoc->m_strDataFilesPath;
	vOpenFile.lpstrTitle = _T("Select Plugins to Repair\0");
	vOpenFile.Flags = OFN_ALLOWMULTISELECT | OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST;
	vOpenFile.lpstrDefExt = strDefExt.GetBuffer(4);

	if(!GetOpenFileName(&vOpenFile))
		return;

	strTempFile.ReleaseBuffer(OPENDIALOG_BUFFERSIZE);
	
	strTempPath = strTempFile.Left(vOpenFile.nFileOffset);

	strTempPath.GetBuffer(0);
	strTempPath.ReleaseBuffer();
	if(strTempPath.Right(1) != "\\")
	{
		strTempPath += _T("\\");
	}
		
	sublength = vOpenFile.nFileOffset;
	count = sublength;
	length = OPENDIALOG_BUFFERSIZE;
	while(count < length && sublength > 1)
	{
		strTempFile.Delete(0,sublength);
		if(strTempFile == "")
			break;
		if(!m_EspFileList.Find(strTempFile,NULL) && 
		   !(strTempFile == m_strDialogEspFile && strTempPath == m_strDialogEspPath))
		{
			m_EspFileList.AddHead(strTempFile);
			m_EspPathList.AddHead(strTempPath);
		}

		sublength = strTempFile.Find('\0') + 1;
		count += sublength;
	}

	m_EspListBox.ResetContent();

	length = m_EspFileList.GetCount();
	pos = m_EspFileList.GetTailPosition();
	for(count = 0;count < length;count++)
	{
		m_EspListBox.AddString(m_EspFileList.GetPrev(pos));
	}
}

void CRepairToolDlg::OnClearlist() 
{
	m_EspListBox.ResetContent();
	m_EspFileList.RemoveAll();
	m_EspPathList.RemoveAll();
}

void CRepairToolDlg::OnCreatenew() 
{
	CString strTempFile;
	CString strFiletitle = "";
	OPENFILENAME vOpenFile;
	CString strDefExt = _T("txt");
	//char strFilter[] = _T("Any File (*.*)\0*.*\0\0");
	char strFilter[] = _T("Plugin Files (*.esp)\0*.esp\0All Files (*.*)\0*.*\0\0");
	vOpenFile.lStructSize = sizeof(vOpenFile); //OPENFILENAME_SIZE_VERSION_400;
	vOpenFile.hwndOwner = AfxGetMainWnd()->GetSafeHwnd();
	vOpenFile.lpstrFilter = strFilter;
	vOpenFile.lpstrCustomFilter = NULL;
	vOpenFile.nFilterIndex = 0;
	vOpenFile.lpstrFile = strTempFile.GetBuffer(1000);
	vOpenFile.nMaxFile = 1000;
	vOpenFile.lpstrFileTitle = NULL;
	vOpenFile.lpstrInitialDir = m_pDoc->m_strDataFilesPath;
	vOpenFile.lpstrTitle = _T("New Dialog Merge Plugin\0");
	vOpenFile.Flags = OFN_EXPLORER | OFN_HIDEREADONLY |
					  OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST | OFN_EXTENSIONDIFFERENT;
	vOpenFile.lpstrDefExt = strDefExt.GetBuffer(4);

	if(!GetSaveFileName(&vOpenFile))
	{
		if(CommDlgExtendedError() != 0)
			AfxGetMainWnd()->MessageBox("Error Selecting File", "Error", MB_OK);

		return;
	}
	strTempFile.ReleaseBuffer();
	
	m_strDialogEspPath = strTempFile.Left(vOpenFile.nFileOffset);
	m_strDialogEspFile = strTempFile.Mid(vOpenFile.nFileOffset);

	if(m_strDialogEspPath.Right(1) != "\\")
	{
		m_strDialogEspPath += _T("\\");
	}

	m_strRepairEsp = m_strDialogEspFile;
	UpdateData(FALSE);
}

void CRepairToolDlg::SetData(CString strEspFile, CString strEspPath, CTESPCDDoc * pDoc)
{
	m_strDialogEspFile = strEspFile;
	m_strDialogEspPath = strEspPath;

	m_pDoc = pDoc;

	m_strRepairEsp = m_strDialogEspFile;
}

CStringList * CRepairToolDlg::GetEspFileList()
{
	return &m_EspFileList;
}

CStringList * CRepairToolDlg::GetEspPathList()
{
	return &m_EspPathList;
}

void CRepairToolDlg::GetRepairPlugin(CString &strEspFile, CString &strEspPath)
{
	strEspFile = m_strDialogEspFile;
	strEspPath = m_strDialogEspPath;
}

void CRepairToolDlg::OnDeleteexist() 
{
	DeleteFile(m_strDialogEspPath + m_strDialogEspFile);
}

void CRepairToolDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	if ( pWnd != (CWnd*) &m_EspListBox)
	{
		CDialog::OnContextMenu(pWnd, point);
		return;
	}
	
	CPoint CurPos;
	CMenu menu; 
	CMenu* pContextMenu;
	
	// Handle Shift-F10
	if (point.x == -1 && point.y == -1)
		point = (CPoint) GetMessagePos();
	
	GetCursorPos(&CurPos);
	m_EspListBox.ScreenToClient(&CurPos);
	
	int iItemIndx = m_EspListBox.GetCurSel();
	if(iItemIndx != LB_ERR)
	{
		menu.LoadMenu(IDR_CONTEXTLIST);

		pContextMenu = menu.GetSubMenu(0);
		pContextMenu->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON, point.x, point.y, this, 0);
	}
}

void CRepairToolDlg::OnListcontextremove() 
{
	CString itemtxt, listtxt;
	int iItemIndx = m_EspListBox.GetCurSel();
	if(iItemIndx != LB_ERR)
	{
		POSITION pos1 = m_EspFileList.GetHeadPosition(); 
		POSITION pos2 = m_EspPathList.GetHeadPosition();

		if(m_EspFileList.GetCount() != 0)
		{
			m_EspListBox.GetText(iItemIndx,itemtxt);
			do
			{ //Check m_EspFileList for Item
				m_EspPathList.GetNext(pos2);
				listtxt = m_EspFileList.GetNext(pos1);
				if(itemtxt == listtxt)
				{
					if(pos1 == NULL)
					{
						m_EspFileList.RemoveTail();
						m_EspPathList.RemoveTail();
					}
					else
					{
						m_EspFileList.GetPrev(pos1);
						m_EspPathList.GetPrev(pos2);
						m_EspFileList.RemoveAt(pos1);
						m_EspPathList.RemoveAt(pos2);
					}
					m_EspListBox.DeleteString(iItemIndx);
				}
			}while(pos1 != NULL && itemtxt != listtxt);		
		}
	}
}

void CRepairToolDlg::OnListcontextadd() 
{	
	OnBrowseesps();
}
