// TESDialogOp.cpp: implementation of the CTESDialogOp class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "tespcd.h"
#include "TESDialogOp.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTESDialogOp::CTESDialogOp()
{

}

CTESDialogOp::~CTESDialogOp()
{
	CPtrArray * pPtrArray;
	CString mapKey;
	POSITION posMap;
	
	posMap = m_EspDialogMap.GetStartPosition();
	while(posMap != NULL)
	{
		m_EspDialogMap.GetNextAssoc(posMap,mapKey,(CObject *&) pPtrArray);
		for(int i = 0;i < pPtrArray->GetSize();i++)
			delete (_sDialEntry *) pPtrArray->GetAt(i);

		pPtrArray->RemoveAll();
		delete (CPtrArray *) pPtrArray;
	}


	posMap = m_EspInfoMap.GetStartPosition();
	while(posMap != NULL)
	{
		m_EspInfoMap.GetNextAssoc(posMap,mapKey,(CObject *&) pPtrArray);
		for(int i = 0;i < pPtrArray->GetSize();i++)
			delete (_sInfoEntry *) pPtrArray->GetAt(i);

		pPtrArray->RemoveAll();
		delete (CPtrArray *) pPtrArray;
	}

	posMap = m_EsmDialogMap.GetStartPosition();
	while(posMap != NULL)
	{
		m_EsmDialogMap.GetNextAssoc(posMap,mapKey,(CObject *&) pPtrArray);
		for(int i = 0;i < pPtrArray->GetSize();i++)
			delete (_sDialEntry *) pPtrArray->GetAt(i);

		pPtrArray->RemoveAll();
		delete (CPtrArray *) pPtrArray;
	}


	posMap = m_EsmInfoMap.GetStartPosition();
	while(posMap != NULL)
	{
		m_EsmInfoMap.GetNextAssoc(posMap,mapKey,(CObject *&) pPtrArray);
		for(int i = 0;i < pPtrArray->GetSize();i++)
			delete (_sInfoEntry *) pPtrArray->GetAt(i);

		pPtrArray->RemoveAll();
		delete (CPtrArray *) pPtrArray;
	}

	posMap = m_OrderedInfoMap.GetStartPosition();
	while(posMap != NULL)
	{
		m_OrderedInfoMap.GetNextAssoc(posMap,mapKey,(CObject *&) pPtrArray);
		for(int i = 0;i < pPtrArray->GetSize();i++)
			delete (_sInfoEntry *) pPtrArray->GetAt(i);

		pPtrArray->RemoveAll();
		delete (CPtrArray *) pPtrArray;
	}


}

BOOL CTESDialogOp::ExtractDialog(BOOL &bForceExit, HANDLE hFile, FILETIME ftLastWriteTime, BOOL bIsEsp)
{
	CString ID,strTemp1, strTemp2;
	CPtrArray* alist;
	_sInfoEntry* aInfoEntry;
	_sDialEntry* aDialEntry;
	BOOL eof = false;
	int cFilePos;
	unsigned char recsize = 0x00;
	unsigned char temp[3];
	unsigned long truesize = 0;
	unsigned long bytesread = 0;
	CString strCurTopic;
	CMapStringToOb * pMapDial, * pMapInfo;

	if(bIsEsp)
	{
		pMapDial = &m_EspDialogMap;
		pMapInfo = &m_EspInfoMap;
	}
	else
	{
		pMapDial = &m_EsmDialogMap;
		pMapInfo = &m_EsmInfoMap;

	}

	try
	{
		do
		{
			ID.Empty();
			if(ReadFile(hFile,ID.GetBuffer(4),4,&bytesread,NULL))
			{
				eof = (bytesread < 4);
			}
			else
			{
				return FALSE;
			}
			ID.ReleaseBuffer(bytesread);

			if(ID == "DIAL")
			{ 
				if(!ReadFile(hFile,&temp,3,&bytesread,NULL))
					return false;

				truesize = (unsigned char) temp[2];
				truesize = truesize<<8;
				truesize += (unsigned char) temp[1];
				truesize = truesize<<8;
				truesize += (unsigned char) temp[0];
				cFilePos = SetFilePointer(hFile,9,NULL,FILE_CURRENT);
				
				aDialEntry = new _sDialEntry;
				aDialEntry->EntryStartPos = cFilePos - 16;
				aDialEntry->EntrySize = truesize + 16;
				aDialEntry->EntryName = GetNext(hFile, "NAME",recsize);
				aDialEntry->EntryName.TrimRight();
				aDialEntry->EntryName.TrimLeft();

				aDialEntry->EntrySizeChange = 0;
				
				truesize -= recsize + 8;
				if(truesize > 0)
				{
					if(ReadFile(hFile,aDialEntry->EntryData.GetBuffer((unsigned int)truesize),(unsigned int)truesize,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return false;
					}

					aDialEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

					if(CheckDeletions(aDialEntry->EntryData))
					{
						delete aDialEntry;
						continue;
					}
				}
				else
				{
					aDialEntry->EntryData = "";
				}
				
				aDialEntry->EntryData.FreeExtra();

				if(!pMapDial->Lookup(aDialEntry->EntryName,(CObject*&)alist))
				{
					(*pMapDial)[aDialEntry->EntryName] = (CObject*) new CPtrArray;
					(*pMapInfo)[aDialEntry->EntryName] = (CObject*) new CPtrArray;
					if(bIsEsp)
					{
						m_OrderedInfoMap[aDialEntry->EntryName] = (CObject*) new CPtrArray;
					}			
					pMapDial->Lookup(aDialEntry->EntryName,(CObject*&)alist);
				}

				alist->Add(aDialEntry);
				strCurTopic = aDialEntry->EntryName;
			}
			else if(ID == "INFO")
			{
				if(!ReadFile(hFile,&temp,3,&bytesread,NULL))
					return false;

				truesize = (unsigned char) temp[2];
				truesize = truesize<<8;
				truesize += (unsigned char) temp[1];
				truesize = truesize<<8;
				truesize += (unsigned char) temp[0];
				cFilePos = SetFilePointer(hFile,9,NULL,FILE_CURRENT);
				
				aInfoEntry = new _sInfoEntry;
				aInfoEntry->EntryStartPos = cFilePos - 16;
				aInfoEntry->EntrySize = truesize + 16;
				aInfoEntry->EntryINAM = GetNext(hFile, "INAM",recsize);
				truesize -= recsize + 8;
				aInfoEntry->EntryPNAM = GetNext(hFile, "PNAM",recsize);
				truesize -= recsize + 8;
				aInfoEntry->EntryNNAM = GetNext(hFile, "NNAM",recsize);
				truesize -= recsize + 8;
				aInfoEntry->EntrySizeChange = 0;
				aInfoEntry->ftLastWriteTime = ftLastWriteTime;
				
				if(truesize > 0)
				{
					if(ReadFile(hFile,aInfoEntry->EntryData.GetBuffer((unsigned int)truesize),(unsigned int)truesize,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return false;
					}

					aInfoEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

					if(CheckDeletions(aInfoEntry->EntryData))
					{
						delete aInfoEntry;
						continue;
					}

				}
				else
				{
					aInfoEntry->EntryData = "";
				}

				aInfoEntry->EntryData.FreeExtra();

				pMapInfo->Lookup(strCurTopic,(CObject*&)alist);
				alist->Add(aInfoEntry);
			}
			else if(ID == "ACTI" || ID == "ALCH" || ID == "APPA" || ID == "ARMO" || ID == "BODY" ||
					ID == "BOOK" || ID == "BSGN" || ID == "CLAS" || ID == "CLOT" || ID == "CONT" ||
					ID == "CREA" || ID == "DOOR" || ID == "ENCH" || ID == "FACT" || ID == "GLOB" || 
					ID == "GMST" || ID == "INGR" || ID == "NPC_" || ID == "MISC" || ID == "LEVC" || 
					ID == "LEVI" || ID == "LIGH" || ID == "LOCK" || ID == "LTEX" || ID == "PROB" ||
					ID == "RACE" || ID == "REGN" || ID == "REPA" || ID == "SNDG" || ID == "SOUN" || 
					ID == "SPEL" || ID == "STAT" || ID == "WEAP" || ID == "PGRD" || ID == "LAND" ||
					ID == "MGEF" || ID == "SKIL" ||	ID == "SCPT" || ID == "CELL" || ID == "MAST" ||
					ID == "SSCR" || ID == "TES3")
			{
				if(!ReadFile(hFile,&temp,3,&bytesread,NULL))
					return FALSE;

				truesize = (unsigned char) temp[2];
				truesize = truesize<<8;
				truesize += (unsigned char) temp[1];
				truesize = truesize<<8;
				truesize += (unsigned char) temp[0];
				
				cFilePos = SetFilePointer(hFile,9,NULL,FILE_CURRENT);

				temp[0] = '\0';
				while(temp[0] == '\0' && bytesread != 0)
				{
					ReadFile(hFile,&temp,1,&bytesread,NULL);
				}

				truesize--;
				cFilePos = SetFilePointer(hFile,(unsigned int)truesize,NULL,FILE_CURRENT);
			}
			else if(!eof)
			{	//Did not find a recognized ID
				#ifdef _DEBUG
					CString *dbgBuf, *dbgVal;
					dbgBuf = new CString;
					dbgVal = new CString;
					ReadFile(hFile,dbgBuf->GetBuffer(20),20,&bytesread,NULL);
					dbgBuf->ReleaseBuffer(bytesread);
					TRACE0(itoa(cFilePos,dbgVal->GetBuffer(33),10));
					TRACE0("\n");
					dbgVal->ReleaseBuffer();
					TRACE0(ID);
					TRACE0(" - ");
					TRACE0(*dbgBuf);
					TRACE0("\n");
					delete dbgBuf;
					delete dbgVal;
					SetFilePointer(hFile,-23,NULL,FILE_CURRENT);
				#else
					SetFilePointer(hFile,-3,NULL,FILE_CURRENT);
				#endif
			}

		}while(!eof && !bForceExit);
	}
	catch(CFileException* ex)
	{
		//TCHAR   szCause[255];
    
		//ex->GetErrorMessage(szCause, 255);
		ex->ReportError();

		//MessageBox(AfxGetMainWnd()->GetSafeHwnd(),szCause,"Critical Error",MB_OK);
		ex->Delete();
		return FALSE;
	}
	
	return TRUE;
}

CString CTESDialogOp::GetNext(HANDLE hFile, const CString searchstr, unsigned char &recsize)
{
	CString name;
	BOOL namefound = false;
	BOOL eof = false;
	DWORD bytesread;
	
	recsize = 0x00;
	
	do
	{
		name.Empty();
		if(ReadFile(hFile,name.GetBuffer(4),4,&bytesread,NULL))
		{
			eof = (bytesread < 4);
		}

		if(name == searchstr)
		{
			namefound = true;
		}
		else if(!eof)
		{
			SetFilePointer(hFile,-3,NULL,FILE_CURRENT);
		}
		
	}while(!eof && !namefound);					
	
	ReadFile(hFile,&recsize,1,&bytesread,NULL);
	
	SetFilePointer(hFile,3,NULL,FILE_CURRENT);

	name.ReleaseBuffer(4);
	
	name.Empty();
	
	ReadFile(hFile,name.GetBuffer((unsigned int)recsize),(unsigned int)recsize,&bytesread,NULL);
	
	name.ReleaseBuffer(bytesread);
	
	name.FreeExtra();

	return name;
}

BOOL CTESDialogOp::CheckDeletions(const CString entryDump)
{

	int nEntryLength = entryDump.GetLength();
	
	if(entryDump.Mid(nEntryLength - 12,4) == "DELE")
		return TRUE;

	return FALSE;
}


BOOL CTESDialogOp::Execute(BOOL &bForceExit)
{
	HANDLE hEspFile;
	HANDLE hEsmFile;
	WIN32_FILE_ATTRIBUTE_DATA fileattrib;;
	_GET_FILEEX_INFO_LEVELS filelevels = GetFileExInfoStandard;

	CString strIdentifyOp = "Extracting Esp Dialog ";
	CString barstr = strIdentifyOp + "0% complete";

	int cEsp = m_EspFilenames.GetSize();
	
	if(!bForceExit)
		SendMessage(AfxGetMainWnd()->GetSafeHwnd(),UDM_STEPPBAR,(UINT)&barstr,(UINT)cEsp);

	for(int i = 0;i < cEsp && !bForceExit;i++)
	{
		
		hEspFile = CreateFile(m_EspDirectories.GetAt(i) + m_EspFilenames.GetAt(i),
					        GENERIC_READ,
							FILE_SHARE_READ | FILE_SHARE_WRITE,
							NULL, OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS,
							NULL);

		if(hEspFile == INVALID_HANDLE_VALUE)
		{
			AfxGetMainWnd()->MessageBox("Could not Open " + m_EspFilenames.GetAt(i),
										"Error",
										MB_ICONEXCLAMATION | MB_OK);
			return FALSE;
		}

		if(!GetFileAttributesEx(m_EspDirectories.GetAt(i) + m_EspFilenames.GetAt(i),
							filelevels,
							&fileattrib))
		{
			CloseHandle(hEspFile);
			return FALSE;
		}

		ExtractDialog(bForceExit,hEspFile,fileattrib.ftLastWriteTime, TRUE);

		CloseHandle(hEspFile);

		barstr.Format(strIdentifyOp + "%d%% complete", i*100/cEsp);
		if(!bForceExit)
			SendMessage(AfxGetMainWnd()->GetSafeHwnd(),UDM_STEPPBAR,(UINT)&barstr,(UINT)cEsp);

	}

	if(!bForceExit)
	{
		//Destroy the Bar
		SendMessage(AfxGetMainWnd()->GetSafeHwnd(),UDM_STEPPBAR,(UINT)&barstr,0);
	}

	strIdentifyOp = "Extracting Esm Dialog ";
	barstr = strIdentifyOp + "0% complete";

	int cEsm = m_EsmFilenames.GetSize();

	if(cEsm <= 0)
	{
		if(IDNO == AfxGetMainWnd()->MessageBox("Master Files Not Found.\nDialog Repair will be incomplete.\nIgnore and Continue?",
									"Caution",
									MB_YESNO | MB_ICONQUESTION))
			return FALSE;
	}
	
	if(!bForceExit)
		SendMessage(AfxGetMainWnd()->GetSafeHwnd(),UDM_STEPPBAR,(UINT)&barstr,(UINT)cEsm);

	for(i = 0;i < cEsm && !bForceExit;i++)
	{
		
		hEsmFile = CreateFile(m_EsmDirectories.GetAt(i) + m_EsmFilenames.GetAt(i),
					        GENERIC_READ,
							FILE_SHARE_READ | FILE_SHARE_WRITE,
							NULL, OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS,
							NULL);

		if(hEsmFile == INVALID_HANDLE_VALUE)
		{
			AfxGetMainWnd()->MessageBox("Could not Open " + m_EsmFilenames.GetAt(i),
										"Error",
										MB_ICONEXCLAMATION | MB_OK);
			return FALSE;
		}

		if(!GetFileAttributesEx(m_EsmDirectories.GetAt(i) + m_EsmFilenames.GetAt(i),
							filelevels,
							&fileattrib))
		{
			CloseHandle(hEsmFile);
			return FALSE;
		}
		
		ExtractDialog(bForceExit,hEsmFile,fileattrib.ftLastWriteTime, FALSE);

		CloseHandle(hEsmFile);

		barstr.Format(strIdentifyOp + "%d%% complete", i*100/cEsm);
		if(!bForceExit)
			SendMessage(AfxGetMainWnd()->GetSafeHwnd(),UDM_STEPPBAR,(UINT)&barstr,(UINT)cEsm);

	}

	if(!bForceExit)
	{
		//Destroy the Bar
		SendMessage(AfxGetMainWnd()->GetSafeHwnd(),UDM_STEPPBAR,(UINT)&barstr,0);
	}

	if(RepairDialog(bForceExit))
	{
		return CreateDialogPlugin(bForceExit, m_strRepairFile);

	}
	else
	{
		return FALSE;
	}
}

BOOL CTESDialogOp::RepairDialog(BOOL &bForceExit)
{
	POSITION posInfo;
	CPtrArray * pEspInfoArray, * pDialArray;
	CPtrArray * pEsmInfoArray, * pOrderedArray;
	CString strTopic;
	_sInfoEntry * pEspInfoEntry1, * pEspInfoEntry2, * pEsmInfoEntry1, * pEsmInfoEntry2;
	int x,y,j,k;
	BOOL bEsmHasTopic = FALSE;
	CString strPrevINAM = "";
	CStringArray NextEsmINAM;

	posInfo = m_EspInfoMap.GetStartPosition();

	while(posInfo != NULL && !bForceExit)
	{
		m_EspInfoMap.GetNextAssoc(posInfo,strTopic,(CObject*&) pEspInfoArray);
		m_EspDialogMap.Lookup(strTopic,(CObject*&) pDialArray);
		bEsmHasTopic = m_EsmInfoMap.Lookup(strTopic,(CObject*&) pEsmInfoArray);
		m_OrderedInfoMap.Lookup(strTopic,(CObject*&) pOrderedArray);

		if(pEspInfoArray->GetSize() == 0)
		{
			continue;
		}

		#ifdef _DEBUG
		if(strTopic == "Greeting 0")
		{
			TRACE0("DEBUG Topic Reached");
		}
		#endif

		if(bEsmHasTopic)
		{
			// Check for Same ID Entries in Esm Files
			for(x = 0;x < pEsmInfoArray->GetSize() && !bForceExit;x++)
			{
				pEsmInfoEntry1 = (_sInfoEntry *) pEsmInfoArray->GetAt(x);
				for(y = x + 1;y < pEsmInfoArray->GetSize() && !bForceExit;y++)
				{
					pEsmInfoEntry2 = (_sInfoEntry *) pEsmInfoArray->GetAt(y);

					if(pEsmInfoEntry1->EntryINAM == pEsmInfoEntry2->EntryINAM)
					{	// Remove Conflicting Entry
						if(CTime(pEsmInfoEntry1->ftLastWriteTime) > CTime(pEsmInfoEntry2->ftLastWriteTime))
						{
							delete (_sInfoEntry *) pEsmInfoEntry2;
							pEsmInfoArray->RemoveAt(y);
							y--;
							continue;
						}
						else
						{
							delete (_sInfoEntry *) pEsmInfoEntry1;
							pEsmInfoArray->RemoveAt(x);
							x--;
							break;
						}
					}

				}
			}

			// Check for Originals or Changed Entries and Handle
			for(x = 0;x < pEspInfoArray->GetSize() && !bForceExit;x++)
			{
				pEspInfoEntry2 = (_sInfoEntry *) pEspInfoArray->GetAt(x);
				for(y = 0;y < pEsmInfoArray->GetSize() && !bForceExit;y++)
				{
					pEsmInfoEntry1 = (_sInfoEntry *) pEsmInfoArray->GetAt(y);		

					if(pEsmInfoEntry1->EntryINAM == pEspInfoEntry2->EntryINAM)
					{ // Exists as Original INFO Entry
						if(EqualCStringBuffers(pEsmInfoEntry1->EntryData,pEspInfoEntry2->EntryData))
						{ // Identical to Original Entry so Delete
							delete (_sInfoEntry *) pEspInfoEntry2;
							pEspInfoArray->RemoveAt(x);
							x--;
							break;

						}
						else
						{	// Changed Original Entry
							pEsmInfoEntry1->EntryData = pEspInfoEntry2->EntryData;
							delete (_sInfoEntry *) pEspInfoEntry2;
							pEspInfoArray->RemoveAt(x);
							x--;
							break;
						}
						
					}

				}
			}

		}

		// Check for Identical or Conflicting Entries
		for(x = 0;x < pEspInfoArray->GetSize() && !bForceExit;x++)
		{
			pEspInfoEntry1 = (_sInfoEntry *) pEspInfoArray->GetAt(x);
			for(y = x + 1;y < pEspInfoArray->GetSize() && !bForceExit;y++)
			{
				pEspInfoEntry2 = (_sInfoEntry *) pEspInfoArray->GetAt(y);

				if(pEspInfoEntry1->EntryINAM == pEspInfoEntry2->EntryINAM)
				{	// Remove Conflicting Dialog

					if(EqualCStringBuffers(pEspInfoEntry1->EntryData,pEspInfoEntry2->EntryData))
					{
						delete (_sInfoEntry *) pEspInfoEntry2;
						pEspInfoArray->RemoveAt(y);
						y--;
						continue;
					}
					else if(IDYES == AfxGetMainWnd()->MessageBox("Conflicting Dialog Found. Ignore and Continue?",
												"Conflict Found", MB_ICONQUESTION | MB_YESNO))
					{
						if(CTime(pEspInfoEntry1->ftLastWriteTime) > CTime(pEspInfoEntry2->ftLastWriteTime))
						{
							delete (_sInfoEntry *) pEspInfoEntry2;
							pEspInfoArray->RemoveAt(y);
							y--;
							continue;
						}
						else
						{
							delete (_sInfoEntry *) pEspInfoEntry1;
							pEspInfoArray->RemoveAt(x);
							x--;
							break;
						}
					}
					else
					{
						return FALSE;
					}
					
				}

			}
		}

		strPrevINAM.Empty();
		// Adds Initial Esp Links if Any
		RecursiveOrdering(strPrevINAM,pEspInfoArray, pOrderedArray, bForceExit);

		while(bEsmHasTopic && pEsmInfoArray->GetSize() > 0)
		{
			for(j = 0;j < pEsmInfoArray->GetSize() && !bForceExit;j++)
			{
				pEsmInfoEntry1 = (_sInfoEntry *) pEsmInfoArray->GetAt(j);
				if(pEsmInfoEntry1->EntryPNAM == strPrevINAM)
				{
					// Fix PNAM
					if(pOrderedArray->GetSize() > 0)
					{
						pEsmInfoEntry1->EntryPNAM = 
						((_sInfoEntry *)pOrderedArray->GetAt(pOrderedArray->GetSize()-1))->EntryINAM;
					}
					else
					{
						pEsmInfoEntry1->EntryPNAM.Empty();
						pEsmInfoEntry1->EntryPNAM.Insert(0,'\0');
					}
					// Fix NNAM
					if(pOrderedArray->GetSize() > 0)
					{
						((_sInfoEntry *)pOrderedArray->GetAt(pOrderedArray->GetSize()-1))->EntryNNAM = pEsmInfoEntry1->EntryINAM;
					}
					pOrderedArray->Add(pEsmInfoEntry1);
					pEsmInfoArray->RemoveAt(j);
					j--;
					
					NextEsmINAM.Add(pEsmInfoEntry1->EntryNNAM);
					// All Esps with this Link are Added
					RecursiveOrdering(pEsmInfoEntry1->EntryINAM, pEspInfoArray, pOrderedArray, bForceExit);				
				}
			}

			if(pEsmInfoArray->GetSize() > 0)
			{
				j = 0;
				if(NextEsmINAM.GetSize() > 0)
				{	
					for(k = 0;k < NextEsmINAM.GetSize() && !bForceExit;k++)
					{	// Remove Duplicates
						for(j = k + 1;j < NextEsmINAM.GetSize() && !bForceExit;j++)
						{
							if(NextEsmINAM.GetAt(j) == NextEsmINAM.GetAt(k))
							{
								NextEsmINAM.RemoveAt(j);
								j--;
							}
						}
					}

					for(j = 0;j < NextEsmINAM.GetSize() && j >= 0 && !bForceExit;j++)
					{
						strPrevINAM = NextEsmINAM.GetAt(j);
						NextEsmINAM.RemoveAt(j);
						j--;
						for(k = 0;k < pEsmInfoArray->GetSize() && !bForceExit;k++)
						{
							pEsmInfoEntry1 = (_sInfoEntry *) pEsmInfoArray->GetAt(k);
							if(pEsmInfoEntry1->EntryINAM == strPrevINAM)
							{
								j = -10;
								break;
							}
						}
					}
				}
				
				if(j >= 0)
				{
					AfxGetMainWnd()->MessageBox("Dialog May Be Out of Order","Warning",MB_OK | MB_ICONEXCLAMATION);
					strPrevINAM = ((_sInfoEntry *)pEsmInfoArray->GetAt(0))->EntryINAM;
					pEsmInfoEntry1 = ((_sInfoEntry *) pEsmInfoArray->GetAt(0));
					k = 0;
				}

				// Fix PNAM
				if(pOrderedArray->GetSize() > 0)
				{
					pEsmInfoEntry1->EntryPNAM = 
					((_sInfoEntry *)pOrderedArray->GetAt(pOrderedArray->GetSize()-1))->EntryINAM;
				}
				else
				{
					pEsmInfoEntry1->EntryPNAM.Empty();
					pEsmInfoEntry1->EntryPNAM.Insert(0,'\0');
				}

				// Fix NNAM
				if(pOrderedArray->GetSize() > 0)
				{
					((_sInfoEntry *)pOrderedArray->GetAt(pOrderedArray->GetSize()-1))->EntryNNAM = pEsmInfoEntry1->EntryINAM;
				}
				pOrderedArray->Add(pEsmInfoEntry1);
				pEsmInfoArray->RemoveAt(k);
				
			}
		}

		// Add Left Over Esp Dialog - This should be Extremely Rare
		for(j = 0;j < pEspInfoArray->GetSize() && !bForceExit;j++)
		{
			pEspInfoEntry1 = (_sInfoEntry *) pEspInfoArray->GetAt(j);

			// Fix PNAM
			if(pOrderedArray->GetSize() > 0)
			{
				pEspInfoEntry1->EntryPNAM = 
				((_sInfoEntry *)pOrderedArray->GetAt(pOrderedArray->GetSize()-1))->EntryINAM;
			}
			else
			{
				pEspInfoEntry1->EntryPNAM.Empty();
				pEspInfoEntry1->EntryPNAM.Insert(0,'\0');
			}
			// Fix NNAM
			if(pOrderedArray->GetSize() > 0)
			{
				((_sInfoEntry *)pOrderedArray->GetAt(pOrderedArray->GetSize()-1))->EntryNNAM = pEspInfoEntry1->EntryINAM;
			}
			pOrderedArray->Add(pEspInfoEntry1);
			pEspInfoArray->RemoveAt(j);
			j--;
			// All Rest in this Link are Added
			RecursiveOrdering(pEspInfoEntry1->EntryINAM, pEspInfoArray, pOrderedArray, bForceExit);
		}

		// Close the End of the Link
		pEspInfoEntry1 = (_sInfoEntry *) pOrderedArray->GetAt(0);
		pEspInfoEntry1->EntryPNAM.Empty();
		pEspInfoEntry1->EntryPNAM.Insert(0,'\0');

		pEspInfoEntry1 = (_sInfoEntry *) pOrderedArray->GetAt(pOrderedArray->GetSize() - 1);
		pEspInfoEntry1->EntryNNAM.Empty();
		pEspInfoEntry1->EntryNNAM.Insert(0,'\0');
	}

	return TRUE;
}


BOOL CTESDialogOp::RecursiveOrdering(CString strPrevINAM, CPtrArray * pEspInfoArray, CPtrArray * pOrderedArray, BOOL &bForceExit)
{
	_sInfoEntry * pEspInfoEntry;

	for(int j = 0;j < pEspInfoArray->GetSize()&& !bForceExit;j++)
	{	// Recreate Dialog Link List
		pEspInfoEntry = (_sInfoEntry *) pEspInfoArray->GetAt(j);
		if(pEspInfoEntry->EntryPNAM == strPrevINAM)
		{
			// Fix PNAM
			if(pOrderedArray->GetSize() > 0)
			{
				pEspInfoEntry->EntryPNAM = 
				((_sInfoEntry *)pOrderedArray->GetAt(pOrderedArray->GetSize()-1))->EntryINAM;
			}
			else
			{
				pEspInfoEntry->EntryPNAM.Empty();
				pEspInfoEntry->EntryPNAM.Insert(0,'\0');
			}
			// Fix NNAM
			if(pOrderedArray->GetSize() > 0)
			{
				((_sInfoEntry *)pOrderedArray->GetAt(pOrderedArray->GetSize()-1))->EntryNNAM = pEspInfoEntry->EntryINAM;
			}
			pOrderedArray->Add(pEspInfoEntry);
			pEspInfoArray->RemoveAt(j);
			j--;
			// All Rest in this Link are Added
			RecursiveOrdering(pEspInfoEntry->EntryINAM, pEspInfoArray, pOrderedArray, bForceExit);
		}
	}
	return TRUE;
}


BOOL CTESDialogOp::CreateDialogPlugin(BOOL &bForceExit, CString MergeFilePath)
{
	int nLen;
	unsigned long nBytesWritten;
	CString TempPath;
	CString RealFilePath;
	CString EntryDataBuf;
	CString strLength;
	POSITION posInfo;
	CPtrArray * pDialArray, * pOrderedArray;
	CString strTopic;
	CString strBuffer;
	_sInfoEntry * pEspInfoEntry;
	_sDialEntry * pDialEntry;
	HANDLE hDialFile;
	int i,j,n;

	unsigned char headerData[362] = {
		0x54, 0x45, 0x53, 0x33, 0x5A, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x48, 0x45, 0x44, 0x52, 0x2C, 0x01, 0x00, 0x00, 0x9A, 0x99, 0x99, 0x3F, 0x00, 0x00, 0x00, 0x00, 
		0x54, 0x45, 0x53, 0x50, 0x43, 0x44, 0x20, 0x44, 0x69, 0x61, 0x6C, 0x6F, 0x67, 0x20, 0x4D, 0x65, 
		0x72, 0x67, 0x65, 0x20, 0x46, 0x69, 0x6C, 0x65, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
		0x19, 0x00, 0x00, 0x00, 0x4D, 0x41, 0x53, 0x54, 0x0E, 0x00, 0x00, 0x00, 0x4D, 0x6F, 0x72, 0x72, 
		0x6F, 0x77, 0x69, 0x6E, 0x64, 0x2E, 0x65, 0x73, 0x6D, 0x00, 0x44, 0x41, 0x54, 0x41, 0x08, 0x00, 
		0x00, 0x00, 0x75, 0x39, 0xC2, 0x04, 0x00, 0x00, 0x00, 0x00
	};

	try
	{

		hDialFile = CreateFile(MergeFilePath, GENERIC_WRITE,
								FILE_SHARE_WRITE | FILE_SHARE_READ,
								NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH,
								NULL);

		if(hDialFile == INVALID_HANDLE_VALUE)
			return FALSE;

		if(!WriteFile(hDialFile,headerData,362,&nBytesWritten,NULL))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}


		CString strIdentifyOp = "Creating Repair Plugin ";
		CString barstr = strIdentifyOp + "0% complete";

		int cEsp = m_OrderedInfoMap.GetCount();
		
		if(!bForceExit)
			SendMessage(AfxGetMainWnd()->GetSafeHwnd(),UDM_STEPPBAR,(UINT)&barstr,(UINT)cEsp);

		posInfo = m_OrderedInfoMap.GetStartPosition();

		for(i = 0;posInfo != NULL && !bForceExit;i++)
		{
			m_OrderedInfoMap.GetNextAssoc(posInfo,strTopic,(CObject*&) pOrderedArray);
			m_EspDialogMap.Lookup(strTopic,(CObject*&) pDialArray);
			
			pDialEntry = (_sDialEntry *) pDialArray->GetAt(0);
			EntryDataBuf.Empty();
				
			EntryDataBuf += "NAME";
			nLen = pDialEntry->EntryName.GetLength();
			strLength.Empty();
			strLength.Insert(0,(unsigned char) nLen);
			nLen = nLen >> 8;
			strLength.Insert(1,(unsigned char) nLen);
			nLen = nLen >> 8;
			strLength.Insert(2,(unsigned char) nLen);
			nLen = nLen >> 8;
			strLength.Insert(3,(unsigned char) nLen);
			EntryDataBuf += strLength;
			EntryDataBuf += pDialEntry->EntryName;

			EntryDataBuf += pDialEntry->EntryData;

			nLen = EntryDataBuf.GetLength();

			for(n = 0;n < 8;n++)
				EntryDataBuf.Insert(0,'\0');

			strLength.Empty();
			strLength.Insert(0,(unsigned char) nLen);
			nLen = nLen >> 8;
			strLength.Insert(1,(unsigned char) nLen);
			nLen = nLen >> 8;
			strLength.Insert(2,(unsigned char) nLen);
			nLen = nLen >> 8;
			strLength.Insert(3,(unsigned char) nLen);
			EntryDataBuf = strLength + EntryDataBuf;
			EntryDataBuf = "DIAL" + EntryDataBuf;	

			if(!WriteFile(hDialFile,EntryDataBuf,EntryDataBuf.GetLength(),&nBytesWritten,NULL))
			{
				AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
			}

			// Write Ordered Info Entries
			for(j = 0;j < pOrderedArray->GetSize() && !bForceExit;j++)
			{
				pEspInfoEntry = (_sInfoEntry *) pOrderedArray->GetAt(j);

				// Build the New Entry Data
				EntryDataBuf.Empty();
					
				EntryDataBuf += "INAM";
				nLen = pEspInfoEntry->EntryINAM.GetLength();
				strLength.Empty();
				strLength.Insert(0,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(1,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(2,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(3,(unsigned char) nLen);
				EntryDataBuf += strLength;
				EntryDataBuf += pEspInfoEntry->EntryINAM;
				EntryDataBuf += "PNAM";
				nLen = pEspInfoEntry->EntryPNAM.GetLength();
				strLength.Empty();
				strLength.Insert(0,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(1,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(2,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(3,(unsigned char) nLen);
				EntryDataBuf += strLength;
				EntryDataBuf += pEspInfoEntry->EntryPNAM;
				EntryDataBuf += "NNAM";
				nLen = pEspInfoEntry->EntryNNAM.GetLength();
				strLength.Empty();
				strLength.Insert(0,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(1,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(2,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(3,(unsigned char) nLen);
				EntryDataBuf += strLength;
				EntryDataBuf += pEspInfoEntry->EntryNNAM;

				EntryDataBuf += pEspInfoEntry->EntryData;

				nLen = EntryDataBuf.GetLength();

				for(n = 0;n < 8;n++)
					EntryDataBuf.Insert(0,'\0');

				strLength.Empty();
				strLength.Insert(0,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(1,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(2,(unsigned char) nLen);
				nLen = nLen >> 8;
				strLength.Insert(3,(unsigned char) nLen);
				EntryDataBuf = strLength + EntryDataBuf;
				EntryDataBuf = "INFO" + EntryDataBuf;

				if(!WriteFile(hDialFile,EntryDataBuf,EntryDataBuf.GetLength(),&nBytesWritten,NULL))
				{
					AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
				}
			}

			barstr.Format(strIdentifyOp + "%d%% complete", i*100/cEsp);
			if(!bForceExit)
				SendMessage(AfxGetMainWnd()->GetSafeHwnd(),UDM_STEPPBAR,(UINT)&barstr,(UINT)cEsp);

		}

		if(!bForceExit)
		{
			//Destroy the Bar
			SendMessage(AfxGetMainWnd()->GetSafeHwnd(),UDM_STEPPBAR,(UINT)&barstr,0);
		}

		if(!CloseHandle(hDialFile))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}
		hDialFile = NULL;

	}
	catch(CFileException *ex)
	{
		LPSTR MessageBuffer;
		DWORD dwBufferLength;
		DWORD dwFormatFlags = FORMAT_MESSAGE_ALLOCATE_BUFFER |
							  FORMAT_MESSAGE_IGNORE_INSERTS |
							  FORMAT_MESSAGE_FROM_SYSTEM;

		DWORD dwLastError = GetLastError();
		dwBufferLength = FormatMessageA(dwFormatFlags,NULL,dwLastError,
							MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
							(LPSTR) &MessageBuffer, 0, NULL);
		if(dwBufferLength > 0)
	    {
			AfxMessageBox(MessageBuffer,MB_OK);
		}
		else
		{
			AfxMessageBox("Could not update this Entry.",MB_OK);
		}

		LocalFree( MessageBuffer );
		if(hDialFile)
			CloseHandle(hDialFile);

		ex->Delete();
		return FALSE;
	}

	return TRUE;
}

void CTESDialogOp::AddEspFile(CString strFilename, CString strDirectory)
{
	m_EspFilenames.Add(strFilename);
	m_EspDirectories.Add(strDirectory);
}

void CTESDialogOp::AddEsmFile(CString strFilename, CString strDirectory)
{
	m_EsmFilenames.Add(strFilename);
	m_EsmDirectories.Add(strDirectory);
}

void CTESDialogOp::AddRepairPlugin(CString strRepairFile)
{
	m_strRepairFile = strRepairFile;
}


BOOL CTESDialogOp::EqualCStringBuffers(CString str1, CString str2)
{	// Returns 0 if Equal
	int str1len = str1.GetLength();
	int str2len = str2.GetLength();

	if(str1len != str2len)
		return false;

	for(int i = 0;i < str1len;i++)
	{
		if(str1[i] != str2[i])
			return false;
	}

	return true;
}