// TESDialogOp.h: interface for the CTESDialogOp class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESDIALOGOP_H__A3EE78B4_8367_4037_B6CD_5701FA76BE2E__INCLUDED_)
#define AFX_TESDIALOGOP_H__A3EE78B4_8367_4037_B6CD_5701FA76BE2E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTESDialogOp  
{
protected:
	struct _sInfoEntry
	{
		CString EntryINAM;
		CString EntryPNAM;
		CString EntryNNAM;
		CString EntryData;
		FILETIME ftLastWriteTime;
		int EntryStartPos;
		int EntrySize;
		int EntrySizeChange;
	};

	struct _sDialEntry
	{
		CString EntryName;
		CString EntryData;
		int EntryStartPos;
		int EntrySize;
		int EntrySizeChange;
	};
public:
	void AddEspFile(CString strFilename, CString strDirectory);
	void AddEsmFile(CString strFilename, CString strDirectory);
	void AddRepairPlugin(CString strRepairFile);
	BOOL Execute(BOOL &bForceExit);
	
	// Constructor / Destructor
	CTESDialogOp();
	virtual ~CTESDialogOp();

protected:
	BOOL ExtractDialog(BOOL &bForceExit, HANDLE hFile, FILETIME ftLastWriteTime, BOOL bIsEsp = TRUE);
	BOOL RepairDialog(BOOL &bForceExit);
	BOOL RecursiveOrdering(CString strPrevINAM, CPtrArray * pEspInfoArray, CPtrArray * pOrderedArray, BOOL &bForceExit);
	BOOL CreateDialogPlugin(BOOL &bForceExit, CString MergeFilePath);

	BOOL CheckDeletions(const CString entryDump);
	CString GetNext(HANDLE hFile, const CString searchstr, unsigned char &recsize);
	BOOL EqualCStringBuffers(CString str1, CString str2);

	CMapStringToOb m_EspDialogMap;
	CMapStringToOb m_EspInfoMap;
	CMapStringToOb m_EsmDialogMap;
	CMapStringToOb m_EsmInfoMap;
	CMapStringToOb m_OrderedInfoMap;

	CStringArray m_EspFilenames;
	CStringArray m_EspDirectories;
	CStringArray m_EsmFilenames;
	CStringArray m_EsmDirectories;

	CString m_strRepairFile;
};

#endif // !defined(AFX_TESDIALOGOP_H__A3EE78B4_8367_4037_B6CD_5701FA76BE2E__INCLUDED_)
