// TESEntry.cpp: implementation of the CTESEntry class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "tespcd.h"
#include "TESEntry.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTESEntry::CTESEntry()
{
	pstrExtra = NULL;
	pEntryNNAM = NULL;
	pEntryPNAM = NULL;
	pftLastWriteTime = NULL;
}

CTESEntry::~CTESEntry()
{
	if(pstrExtra != NULL)
		delete (CString *) pstrExtra;

	if(pEntryNNAM != NULL)
		delete (CString *) pEntryNNAM;

	if(pEntryPNAM != NULL)
		delete (CString *) pEntryPNAM;

	if(pftLastWriteTime != NULL)
		delete (FILETIME *) pftLastWriteTime;
}

//////////////////////////////////////////////////////////////////////
// Copy Constructor
//////////////////////////////////////////////////////////////////////

CTESEntry::CTESEntry(const CTESEntry &Copy)
{
	bIsDeleted = Copy.bIsDeleted;
	EntryName = Copy.EntryName;
	EntryData = Copy.EntryData;
	EntrySize = Copy.EntrySize;
	EntrySizeChange = Copy.EntrySizeChange;
	EntryStartPos = Copy.EntryStartPos;

	if(Copy.pstrExtra != NULL)
	{
		pstrExtra = new CString;
		*pstrExtra = *Copy.pstrExtra;
	}
	else
	{
		pstrExtra = NULL;
	}

	if(Copy.pEntryNNAM != NULL)
	{
		pEntryNNAM = new CString;
		*pEntryNNAM = *Copy.pEntryNNAM;
	}
	else
	{
		pEntryNNAM = NULL;
	}

	if(Copy.pEntryPNAM != NULL)
	{
		pEntryPNAM = new CString;
		*pEntryPNAM = *Copy.pEntryPNAM;
	}
	else
	{
		pEntryPNAM = NULL;
	}

	if(Copy.pftLastWriteTime != NULL)
	{
		pftLastWriteTime = new FILETIME;
		*pftLastWriteTime = *Copy.pftLastWriteTime;
	}
	else
	{
		pftLastWriteTime = NULL;
	}
}

//////////////////////////////////////////////////////////////////////
// Operator Functions
//////////////////////////////////////////////////////////////////////

void CTESEntry::operator =(const CTESEntry &Copy)
{

	bIsDeleted = Copy.bIsDeleted;
	EntryName = Copy.EntryName;
	EntryData = Copy.EntryData;
	EntrySize = Copy.EntrySize;
	EntrySizeChange = Copy.EntrySizeChange;
	EntryStartPos = Copy.EntryStartPos;

	if(Copy.pstrExtra != NULL)
	{
		pstrExtra = new CString;
		*pstrExtra = *Copy.pstrExtra;
	}
	else
	{
		pstrExtra = NULL;
	}

	if(Copy.pEntryNNAM != NULL)
	{
		pEntryNNAM = new CString;
		*pEntryNNAM = *Copy.pEntryNNAM;
	}
	else
	{
		pEntryNNAM = NULL;
	}

	if(Copy.pEntryPNAM != NULL)
	{
		pEntryPNAM = new CString;
		*pEntryPNAM = *Copy.pEntryPNAM;
	}
	else
	{
		pEntryPNAM = NULL;
	}

	if(Copy.pftLastWriteTime != NULL)
	{
		pftLastWriteTime = new FILETIME;
		*pftLastWriteTime = *Copy.pftLastWriteTime;
	}
	else
	{
		pftLastWriteTime = NULL;
	}

}

//////////////////////////////////////////////////////////////////////
// Member Functions
//////////////////////////////////////////////////////////////////////

VOID CTESEntry::SetMode(int iEntryMode)
{
	switch(iEntryMode)
	{
	case INFOMODE:
		pEntryNNAM = new CString;
		pEntryPNAM = new CString;
		pftLastWriteTime = new FILETIME;
		break;
	default:
		pEntryNNAM = NULL;
		pEntryPNAM = NULL;
		pftLastWriteTime = NULL;
	}
}
