// TESEntry.h: interface for the CTESEntry class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESENTRY_H__9ABC8315_EEB7_455D_A570_5ABC059D01F2__INCLUDED_)
#define AFX_TESENTRY_H__9ABC8315_EEB7_455D_A570_5ABC059D01F2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum
{
	NOMODE,
	INFOMODE,
};

class CTESEntry  
{
public:

	// ----Constructor / Destructor----
	CTESEntry();	
	virtual ~CTESEntry();
	CTESEntry(const CTESEntry &Copy);

	// ----Operators----
	void operator =(const CTESEntry &Copy);

	// ----Member Functions----

	// Determines if Extra Variables are initialized
	void SetMode(int iEntryMode = 0);

	// ----Member Variables----

	// Name for this Entry - Used for Conflict Checks
	CString EntryName;
	// All Data After Name
	CString EntryData;
	// This Variable Functions as an alternate Compare for Conflict Checks
	CString * pstrExtra;
	// Variables initialized if INFOMODE
	CString * pEntryNNAM;
	CString * pEntryPNAM;
	FILETIME * pftLastWriteTime;
	// Variable Set if This Entry is Marked as Deleted
	BOOL bIsDeleted;
	// File Offset Position for the Entry
	int EntryStartPos;
	// Size of Entry in Bytes
	int EntrySize;
	// Change in Size of Entry Since Program Started
	int EntrySizeChange;
};

#endif // !defined(AFX_TESENTRY_H__9ABC8315_EEB7_455D_A570_5ABC059D01F2__INCLUDED_)
