
#include "stdafx.h"
#include "TESFile.h"

//Constructor
CTESFile::CTESFile()
{
	m_bFileopen = FALSE;
	m_bBackupCreated = FALSE;
	m_hFile = NULL;
	m_strBackupPath == "";

	//Setup Name structures
	m_EntryMap["ACTI"] = (CObject*)&m_EntryType.ACTI;
	m_EntryMap["ALCH"] = (CObject*)&m_EntryType.ALCH;
	m_EntryMap["APPA"] = (CObject*)&m_EntryType.APPA;
	m_EntryMap["ARMO"] = (CObject*)&m_EntryType.ARMO;
	m_EntryMap["BODY"] = (CObject*)&m_EntryType.BODY;
	m_EntryMap["BOOK"] = (CObject*)&m_EntryType.BOOK;
	m_EntryMap["BSGN"] = (CObject*)&m_EntryType.BSGN;
	m_EntryMap["CELL"] = (CObject*)&m_EntryType.CELL;
	m_EntryMap["CLAS"] = (CObject*)&m_EntryType.CLAS;
	m_EntryMap["CLOT"] = (CObject*)&m_EntryType.CLOT;
	m_EntryMap["CONT"] = (CObject*)&m_EntryType.CONT;
	m_EntryMap["CREA"] = (CObject*)&m_EntryType.CREA;
	m_EntryMap["DIAL"] = (CObject*)&m_EntryType.DIAL;
	m_EntryMap["DOOR"] = (CObject*)&m_EntryType.DOOR;
	m_EntryMap["ENCH"] = (CObject*)&m_EntryType.ENCH;
	m_EntryMap["FACT"] = (CObject*)&m_EntryType.FACT;
	m_EntryMap["GLOB"] = (CObject*)&m_EntryType.GLOB;
	m_EntryMap["GMST"] = (CObject*)&m_EntryType.GMST;
	m_EntryMap["INGR"] = (CObject*)&m_EntryType.INGR;
	m_EntryMap["INFO"] = (CObject*)&m_EntryType.INFO;
	m_EntryMap["LAND"] = (CObject*)&m_EntryType.LAND;
	m_EntryMap["LEVC"] = (CObject*)&m_EntryType.LEVC;
	m_EntryMap["LEVI"] = (CObject*)&m_EntryType.LEVI;
	m_EntryMap["LIGH"] = (CObject*)&m_EntryType.LIGH;
	m_EntryMap["LOCK"] = (CObject*)&m_EntryType.LOCK;
	m_EntryMap["LTEX"] = (CObject*)&m_EntryType.LTEX;
	m_EntryMap["MGEF"] = (CObject*)&m_EntryType.MGEF;
	m_EntryMap["MISC"] = (CObject*)&m_EntryType.MISC;
	m_EntryMap["NPC_"] = (CObject*)&m_EntryType.NPC_;
	m_EntryMap["PGRD"] = (CObject*)&m_EntryType.PGRD;
	m_EntryMap["PROB"] = (CObject*)&m_EntryType.PROB;
	m_EntryMap["RACE"] = (CObject*)&m_EntryType.RACE;
	m_EntryMap["REGN"] = (CObject*)&m_EntryType.REGN;
	m_EntryMap["REPA"] = (CObject*)&m_EntryType.REPA;
	m_EntryMap["SCPT"] = (CObject*)&m_EntryType.SCPT;
	m_EntryMap["SKIL"] = (CObject*)&m_EntryType.SKIL;
	m_EntryMap["SNDG"] = (CObject*)&m_EntryType.SNDG;
	m_EntryMap["SOUN"] = (CObject*)&m_EntryType.SOUN;
	m_EntryMap["SPEL"] = (CObject*)&m_EntryType.SPEL;
	m_EntryMap["STAT"] = (CObject*)&m_EntryType.STAT;
	m_EntryMap["WEAP"] = (CObject*)&m_EntryType.WEAP;
	
}

CTESFile::~CTESFile()
{
	int i,j,cPArray;
	CString key;
	CPtrArray* pPArray;

	POSITION posMap = m_EntryMap.GetStartPosition();
	int cMap = m_EntryMap.GetCount();

	for(i = 0;i < cMap;i++)
	{
		m_EntryMap.GetNextAssoc(posMap,key,(CObject*&)pPArray);
		if(key != "FILE" && key != "PATH")
		{
			cPArray = pPArray->GetSize();

			for(j = 0;j < cPArray;j++)
			{
				delete (CTESEntry*) pPArray->GetAt(j);
			}
			pPArray->RemoveAll();
		}
	}

	cPArray = m_aDeletedEntries.GetSize();
	for(i = 0;i < cPArray;i++)
	{
		delete (CTESEntry*) m_aDeletedEntries.GetAt(i);
	}
	m_aDeletedEntries.RemoveAll();
}

BOOL CTESFile::OpenFile(const CString espfile,const CString espdir)
{
	if(m_bFileopen == TRUE && m_hFile != INVALID_HANDLE_VALUE)
		CloseHandle(m_hFile);

	CTESFile::m_strFilename = espfile;
	CTESFile::m_strFilename.ReleaseBuffer();
	CTESFile::m_strDirectory = espdir;
	CTESFile::m_strDirectory.ReleaseBuffer();
	m_EntryMap["FILE"] = (CObject*)&m_strFilename;
	m_EntryMap["PATH"] = (CObject*)&m_strDirectory;

	m_hFile = CreateFile(espdir + espfile,
                GENERIC_READ,
                FILE_SHARE_READ | FILE_SHARE_WRITE,
                NULL,
                OPEN_EXISTING,
                FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS,
				NULL);

	if(m_hFile != INVALID_HANDLE_VALUE)
		m_bFileopen = TRUE;

	return (m_hFile != INVALID_HANDLE_VALUE);
}

void CTESFile::CloseFile()
{
	if(CloseHandle(m_hFile))
	{
		m_hFile = NULL;
	}
}

BOOL CTESFile::ExtractData(BOOL &ForceExit, CTESFile::_sExtractOpt * extractOpt)
{
	CString ID,strTemp1, strTemp2, strTemp3, strTemp4;
	CString curDIAL = "";
	CPtrArray * alist;
	CTESEntry * aEntry;
	BOOL eof = FALSE;
	ULONG cFilePos;
	PSHORT pShort;
	UCHAR recsize = 0x00;
	UCHAR temp[3];
	ULONG cRemainingData = 0;
	ULONG bytesread = 0;

	try
	{
	
		do
		{
			ID.Empty();
			if(ReadFile(m_hFile,ID.GetBuffer(4),4,&bytesread,NULL))
			{
				eof = (bytesread < 4);
			}
			else
			{
				return FALSE;
			}
			ID.ReleaseBuffer(bytesread);

			if(ID == "ACTI" || ID == "ALCH" || ID == "APPA" || ID == "ARMO" || ID == "BODY" ||
			   ID == "BOOK"	|| ID == "BSGN" || ID == "CLAS" || ID == "CLOT" || ID == "CONT" ||
			   ID == "CREA" || ID == "DOOR" || ID == "ENCH" || ID == "FACT" || ID == "GLOB" || 
			   ID == "GMST" || ID == "INGR" || ID == "NPC_" || ID == "MISC" || ID == "LEVC" || 
			   ID == "LEVI" || ID == "LIGH" || ID == "LOCK" || ID == "LTEX" || ID == "PROB" ||
			   ID == "RACE" || ID == "REGN" || ID == "REPA" || ID == "SNDG" || ID == "SOUN" || 
			   ID == "SPEL" || ID == "STAT" || ID == "WEAP")
			{
				GetNextSize(cRemainingData);

				cFilePos = SetFilePointer(m_hFile,8,NULL,FILE_CURRENT);
				
				aEntry = new CTESEntry;
				aEntry->EntryStartPos = cFilePos - 16;
				aEntry->EntrySize = cRemainingData + 16;
				aEntry->EntryName = GetNext("NAME",&recsize);
				aEntry->EntrySizeChange = 0;

				cRemainingData -= recsize + 8;
				if(cRemainingData > 0)
				{
					if(ReadFile(m_hFile,aEntry->EntryData.GetBuffer((unsigned int)cRemainingData),(unsigned int)cRemainingData,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return FALSE;
					}

					aEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

					aEntry->bIsDeleted = CheckDeletions(aEntry->EntryData);
				}
				else
				{
					aEntry->EntryData = "";
					aEntry->bIsDeleted = FALSE;
				}
					
				aEntry->EntryData.FreeExtra();

				m_EntryMap.Lookup(ID,(CObject*&)alist);
				alist->Add(aEntry);		
			}
			else if(ID == "DIAL")
			{
				GetNextSize(cRemainingData);

				cFilePos = SetFilePointer(m_hFile,8,NULL,FILE_CURRENT);
				
				aEntry = new CTESEntry;
				aEntry->EntryStartPos = cFilePos - 16;
				aEntry->EntrySize = cRemainingData + 16;
				aEntry->EntryName = GetNext("NAME",&recsize);

				// Save Current Dialog Topic
				curDIAL = aEntry->EntryName;

				aEntry->EntrySizeChange = 0;

				cRemainingData -= recsize + 8;
				if(cRemainingData > 0)
				{
					if(ReadFile(m_hFile,aEntry->EntryData.GetBuffer((unsigned int)cRemainingData),(unsigned int)cRemainingData,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return FALSE;
					}

					aEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

					aEntry->bIsDeleted = CheckDeletions(aEntry->EntryData);
				}
				else
				{
					aEntry->EntryData = "";
					aEntry->bIsDeleted = FALSE;
				}
					
				aEntry->EntryData.FreeExtra();

				m_EntryMap.Lookup(ID,(CObject*&)alist);
				alist->Add(aEntry);	
			}
			else if(ID == "INFO")
			{
				GetNextSize(cRemainingData);

				cFilePos = SetFilePointer(m_hFile,8,NULL,FILE_CURRENT);
				
				aEntry = new CTESEntry;
				aEntry->EntryStartPos = cFilePos - 16;
				aEntry->EntrySize = cRemainingData + 16;
				aEntry->EntryName = GetNext("INAM",&recsize);
				cRemainingData -= recsize + 8;
				GetNext("PNAM",&recsize);
				cRemainingData -= recsize + 8;
				GetNext("NNAM",&recsize);
				cRemainingData -= recsize + 8;
				aEntry->EntrySizeChange = 0;
				// Save Current Topic
				aEntry->pstrExtra = new CString;
				*aEntry->pstrExtra = curDIAL;

				if(cRemainingData > 0)
				{
					if(ReadFile(m_hFile,aEntry->EntryData.GetBuffer((unsigned int)cRemainingData),(unsigned int)cRemainingData,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return FALSE;
					}

					aEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

					aEntry->bIsDeleted = CheckDeletions(aEntry->EntryData);
				}
				else
				{
					aEntry->EntryData = "";
					aEntry->bIsDeleted = FALSE;
				}
				aEntry->EntryData.FreeExtra();
				
				if(!extractOpt->bIncINFO)
				{
					aEntry->EntryData = "";
				}

				m_EntryMap.Lookup(ID,(CObject*&)alist);
				alist->Add(aEntry);
			}
			else if(ID == "MGEF" || ID == "SKIL")
			{
				GetNextSize(cRemainingData);

				cFilePos = SetFilePointer(m_hFile,8,NULL,FILE_CURRENT);
				
				aEntry = new CTESEntry;
				aEntry->EntryStartPos = cFilePos - 16;
				aEntry->EntrySize = cRemainingData + 16;
				aEntry->EntryName = GetNext("INDX",&recsize);
				aEntry->EntrySizeChange = 0;
				
				itoa((unsigned int)aEntry->EntryName[0],aEntry->EntryName.GetBuffer(2),10);//Convert to Ascii
				aEntry->EntryName.ReleaseBuffer();
				aEntry->EntryName = "Index " + aEntry->EntryName;
				
				cRemainingData -= recsize + 8;
				if(cRemainingData > 0)
				{
					if(ReadFile(m_hFile,aEntry->EntryData.GetBuffer((unsigned int)cRemainingData),(unsigned int)cRemainingData,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return FALSE;
					}

					aEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

					aEntry->bIsDeleted = CheckDeletions(aEntry->EntryData);
				}
				else
				{
					aEntry->EntryData = "";
					aEntry->bIsDeleted = FALSE;
				}

				aEntry->EntryData.FreeExtra();

				m_EntryMap.Lookup(ID,(CObject*&)alist);
				alist->Add(aEntry);
				
			}
			else if(ID == "SCPT")
			{
				GetNextSize(cRemainingData);

				cFilePos = SetFilePointer(m_hFile,8,NULL,FILE_CURRENT);
				
				aEntry = new CTESEntry;
				aEntry->EntryStartPos = cFilePos - 16;
				aEntry->EntrySize = cRemainingData + 16;
				aEntry->EntryName = GetNext("SCHD",&recsize);
				aEntry->EntrySizeChange = 0;
				
				cRemainingData -= recsize + 8;
				if(cRemainingData > 0)
				{
					if(ReadFile(m_hFile,aEntry->EntryData.GetBuffer((unsigned int)cRemainingData),(unsigned int)cRemainingData,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return FALSE;
					}

					aEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

					aEntry->bIsDeleted = CheckDeletions(aEntry->EntryData);
				}
				else
				{
					aEntry->EntryData = "";
					aEntry->bIsDeleted = FALSE;
				}

				aEntry->EntryData.FreeExtra();

				m_EntryMap.Lookup(ID,(CObject*&)alist);
				alist->Add(aEntry);
				
			}
			else if(ID == "CELL")
			{
				GetNextSize(cRemainingData);

				cFilePos = SetFilePointer(m_hFile,8,NULL,FILE_CURRENT);
				
				aEntry = new CTESEntry;
				aEntry->EntryStartPos = cFilePos - 16;
				aEntry->EntrySize = cRemainingData + 16;
				strTemp4 = GetNext("NAME",&recsize);
				cRemainingData -= recsize + 8;
				
				strTemp1.Empty();

				aEntry->EntryName = GetNext("DATA",&recsize, &strTemp1);
				cRemainingData -= recsize + 8;
				
				if(strTemp1 == "DELE")
				{
					aEntry->bIsDeleted = TRUE;
					aEntry->EntryName = GetNext("DATA",&recsize, &strTemp1);
					cRemainingData -= recsize + 8;
				}
				else
				{
					aEntry->bIsDeleted = FALSE;
				}

				aEntry->EntrySizeChange = 0;
				
				pShort = (short *) aEntry->EntryName.GetBuffer(12);
				itoa((int)*pShort,strTemp1.GetBuffer(6),10);//Convert to Ascii
				strTemp1.ReleaseBuffer();
				pShort += 2;
				itoa((int)*pShort,strTemp2.GetBuffer(6),10);//Convert to Ascii
				strTemp2.ReleaseBuffer();
				pShort += 2;
				itoa((int)*pShort,strTemp3.GetBuffer(6),10);//Convert to Ascii
				strTemp3.ReleaseBuffer();

				aEntry->EntryName.ReleaseBuffer(0);
				aEntry->EntryName = strTemp1 + "," + strTemp2 + "," + strTemp3 + " " + strTemp4;
				
				if(cRemainingData > 0)
				{
					if(ReadFile(m_hFile,aEntry->EntryData.GetBuffer((unsigned int)cRemainingData),(unsigned int)cRemainingData,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return FALSE;
					}

					aEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

				}
				else
				{
					aEntry->EntryData = "";
				}
				aEntry->EntryData.FreeExtra();

				if(!extractOpt->bIncCELL)
				{
					aEntry->EntryData = "";
				}

				m_EntryMap.Lookup(ID,(CObject*&)alist);
				alist->Add(aEntry);
				
			}
			else if(ID == "LAND")
			{
				GetNextSize(cRemainingData);

				cFilePos = SetFilePointer(m_hFile,8,NULL,FILE_CURRENT);
				
				aEntry = new CTESEntry;
				aEntry->EntryStartPos = cFilePos - 16;
				aEntry->EntrySize = cRemainingData + 16;
				aEntry->EntryName = GetNext("INTV",&recsize);
				aEntry->EntrySizeChange = 0;
				
				pShort = (short *) aEntry->EntryName.GetBuffer(8);
				itoa((int)*pShort,strTemp1.GetBuffer(6),10);//Convert to Ascii
				strTemp1.ReleaseBuffer();
				pShort += 2;
				itoa((int)*pShort,strTemp2.GetBuffer(6),10);//Convert to Ascii
				strTemp2.ReleaseBuffer();
				aEntry->EntryName.ReleaseBuffer(0);
				aEntry->EntryName = strTemp1 + "," + strTemp2;
				
				cRemainingData -= recsize + 8;

				if(cRemainingData > 0)
				{
					if(ReadFile(m_hFile,aEntry->EntryData.GetBuffer((unsigned int)cRemainingData),(unsigned int)cRemainingData,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return FALSE;
					}

					aEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

					aEntry->bIsDeleted = CheckDeletions(aEntry->EntryData);
				}
				else
				{
					aEntry->EntryData = "";
					aEntry->bIsDeleted = FALSE;
				}
				aEntry->EntryData.FreeExtra();
			
				if(!extractOpt->bIncLAND)
				{
					aEntry->EntryData = "";
				}

				m_EntryMap.Lookup(ID,(CObject*&)alist);
				alist->Add(aEntry);
				
			}
			else if(ID == "PGRD")
			{
				GetNextSize(cRemainingData);

				cFilePos = SetFilePointer(m_hFile,8,NULL,FILE_CURRENT);
				
				aEntry = new CTESEntry;
				aEntry->EntryStartPos = cFilePos - 16;
				aEntry->EntrySize = cRemainingData + 16;
				
				strTemp1.Empty();

				aEntry->EntryName = GetNext("DATA",&recsize, &strTemp1);
				cRemainingData -= recsize + 8;
				strTemp4 = GetNext("NAME",&recsize);
				cRemainingData -= recsize + 8;

				aEntry->EntrySizeChange = 0;
				
				pShort = (short *) aEntry->EntryName.GetBuffer(12);
				itoa((int)*pShort,strTemp1.GetBuffer(6),10);//Convert to Ascii
				strTemp1.ReleaseBuffer();
				pShort += 2;
				itoa((int)*pShort,strTemp2.GetBuffer(6),10);//Convert to Ascii
				strTemp2.ReleaseBuffer();
				pShort += 2;
				itoa((int)*pShort,strTemp3.GetBuffer(6),10);//Convert to Ascii
				strTemp3.ReleaseBuffer();

				aEntry->EntryName.ReleaseBuffer(0);
				aEntry->EntryName = strTemp1 + "," + strTemp2 + "," + strTemp3 + " " + strTemp4;
				
				if(cRemainingData > 0)
				{
					if(ReadFile(m_hFile,aEntry->EntryData.GetBuffer((unsigned int)cRemainingData),(unsigned int)cRemainingData,&bytesread,NULL))
					{
						eof = (bytesread == 0);
					}
					else
					{
						return FALSE;
					}

					aEntry->EntryData.ReleaseBuffer((unsigned int)bytesread);

					aEntry->bIsDeleted = CheckDeletions(aEntry->EntryData);
				}
				else
				{
					aEntry->EntryData = "";
					aEntry->bIsDeleted = FALSE;
				}
				aEntry->EntryData.FreeExtra();
				
				if(!extractOpt->bIncPGRD)
				{
					aEntry->EntryData = "";
				}

				m_EntryMap.Lookup(ID,(CObject*&)alist);
				alist->Add(aEntry);
				
			}
			else if(ID == "MAST" ||
					ID == "SSCR" || ID == "TES3")
			{
				GetNextSize(cRemainingData);

				cFilePos = SetFilePointer(m_hFile,8,NULL,FILE_CURRENT);

				temp[0] = '\0';
				while(temp[0] == '\0' && bytesread != 0)
				{
					ReadFile(m_hFile,&temp,1,&bytesread,NULL);
				}

				cRemainingData--;
				cFilePos = SetFilePointer(m_hFile,(UINT)cRemainingData,NULL,FILE_CURRENT);
			}
			else if(!eof)
			{	//Did not find a recognized ID
				#ifdef _DEBUG
					CString *dbgBuf, *dbgVal;
					dbgBuf = new CString;
					dbgVal = new CString;
					ReadFile(m_hFile,dbgBuf->GetBuffer(20),20,&bytesread,NULL);
					dbgBuf->ReleaseBuffer(bytesread);
					TRACE0(m_strFilename + " - "+ itoa(cFilePos,dbgVal->GetBuffer(33),10) + "\n");
					dbgVal->ReleaseBuffer();
					TRACE0(ID);
					TRACE0(" - ");
					TRACE0(*dbgBuf);
					TRACE0("\n");
					delete dbgBuf;
					delete dbgVal;
					cFilePos = SetFilePointer(m_hFile,-23,NULL,FILE_CURRENT);
				#else
					SetFilePointer(m_hFile,-3,NULL,FILE_CURRENT);
				#endif
			}

		}while(!eof && !ForceExit);
	}
	catch(CFileException* pEx)
	{
		pEx->ReportError(MB_OK | MB_ICONSTOP);

		pEx->Delete();

		return FALSE;
	}
	
	return TRUE;
}

// Locates next 4 character strSpecifiedSubID ID and returns the string following that ID

CString CTESFile::GetNext(const CString strSpecifiedSubID, UCHAR * cRemainingData, CString * strSubIDFound)
{
	CString strSubID;
	BOOL bSubIDFound = FALSE;
	BOOL bEOF = FALSE;
	DWORD dwBytesRead;
	
	*cRemainingData = 0x00;
	
	do
	{
		strSubID.Empty();
		if(ReadFile(m_hFile,strSubID.GetBuffer(4),4,&dwBytesRead,NULL))
		{
			bEOF = (dwBytesRead < 4);
		}

		if(strSubID == strSpecifiedSubID || strSubIDFound != NULL)
		{
			bSubIDFound = TRUE;
		}
		else if(!bEOF)
		{
			SetFilePointer(m_hFile,-3,NULL,FILE_CURRENT);
		}
		
	}while(!bEOF && !bSubIDFound);					
	
	strSubID.ReleaseBuffer(4);

	if(strSubIDFound != NULL)
		*strSubIDFound = strSubID;

	ReadFile(m_hFile,cRemainingData,1,&dwBytesRead,NULL);
	
	SetFilePointer(m_hFile,3,NULL,FILE_CURRENT);
	
	strSubID.Empty();
	
	ReadFile(m_hFile,strSubID.GetBuffer((unsigned int)*cRemainingData),(unsigned int)*cRemainingData,&dwBytesRead,NULL);
	
	strSubID.ReleaseBuffer(dwBytesRead);
	
	strSubID.FreeExtra();

	return strSubID;
}

BOOL CTESFile::GetNextSize(ULONG &cSize)
{
	UCHAR szBuffer[4];
	DWORD dwBytesRead;

	if(!ReadFile(m_hFile,szBuffer,4,&dwBytesRead,NULL))
		return FALSE;

	cSize = (UCHAR) szBuffer[2];
	cSize = cSize<<8;
	cSize += (UCHAR) szBuffer[1];
	cSize = cSize<<8;
	cSize += (UCHAR) szBuffer[0];
	
	return TRUE;
}

BOOL CTESFile::CheckDeletions(const CString entryDump)
{

	int nEntryLength = entryDump.GetLength();
	
	if(entryDump.Mid(nEntryLength - 12,4) == "DELE")
		return TRUE;

	return FALSE;
}

BOOL CTESFile::ParseEntry(CStringArray *&SubID, CStringArray *&SubData, const CTESEntry EntrytoParse)
{
	CString SubEntryID;
	CString SubEntryData;
	unsigned long cSubEntryLen = 0;
	int cEntryPos = 0;
	int nEntrySize = EntrytoParse.EntryData.GetLength();
	
	if(nEntrySize < 4)
	{
		return FALSE;
	}

	do
	{
		SubEntryID = EntrytoParse.EntryData.Mid(cEntryPos,4);
		cEntryPos += 4;

		cSubEntryLen = (unsigned char) EntrytoParse.EntryData[cEntryPos + 2];
		cSubEntryLen = cSubEntryLen<<8;
		cSubEntryLen += (unsigned char) EntrytoParse.EntryData[cEntryPos + 1];
		cSubEntryLen = cSubEntryLen<<8;
		cSubEntryLen += (unsigned char) EntrytoParse.EntryData[cEntryPos];
		cEntryPos += 4;

		SubEntryData = EntrytoParse.EntryData.Mid(cEntryPos,cSubEntryLen);
		cEntryPos += cSubEntryLen;

		SubID->Add(SubEntryID);
		SubData->Add(SubEntryData);

	} while(cEntryPos < nEntrySize);

	return TRUE;

}

BOOL CTESFile::CreateBackupFile(CString RealFilePath, BOOL SilentMode)
{
	WIN32_FIND_DATA sFindData;
	OPENFILENAME vOpenFile;
	CString strFile;
	CString strDefExt;
	HANDLE hFindFile;
	int nMsgBoxResult = 0;

	if(!m_bBackupCreated)
	{
		if(m_strBackupPath == "")
			m_strBackupPath = RealFilePath.Left(RealFilePath.GetLength() - 3) + "OLD";

		hFindFile = FindFirstFile(m_strBackupPath,&sFindData);
		if(hFindFile != INVALID_HANDLE_VALUE)
		{
			FindClose(hFindFile);

			if(SilentMode)
			{
				nMsgBoxResult = IDNO;
			}
			else
			{
				nMsgBoxResult = MessageBox(AfxGetMainWnd()->GetSafeHwnd(),m_strBackupPath + "\nBackup File Exists, Create a new Backup?",
							"File Exists", MB_YESNOCANCEL | MB_ICONQUESTION | MB_DEFBUTTON2);
			}

			if(nMsgBoxResult == IDYES)
			{
				//Get New BackupFilename
				strFile = _T(*(CString*)m_EntryMap["FILE"]);
				strFile = strFile.Left(strFile.GetLength() - 3) + "OLD";
				strDefExt = _T("OLD");
				char strFilter[] = _T("Any File (*.*)\0*.*\0\0");
				vOpenFile.lStructSize = sizeof(vOpenFile); //OPENFILENAME_SIZE_VERSION_400;
				vOpenFile.hwndOwner = AfxGetMainWnd()->GetSafeHwnd();
				vOpenFile.lpstrFilter = strFilter;
				vOpenFile.lpstrCustomFilter = NULL;
				vOpenFile.nFilterIndex = 0;
				vOpenFile.lpstrFile = strFile.GetBuffer(1000);
				vOpenFile.nMaxFile = 1000;
				vOpenFile.lpstrFileTitle = NULL;
				vOpenFile.lpstrInitialDir = _T(*(CString*)m_EntryMap["PATH"]);
				vOpenFile.lpstrTitle = _T("Select a Backup Filename\0");
				vOpenFile.Flags = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST |
								  OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST | OFN_EXTENSIONDIFFERENT;
				vOpenFile.lpstrDefExt = strDefExt.GetBuffer(4);

				strFile.ReleaseBuffer();

				if(!GetSaveFileName(&vOpenFile))
				{
					if(CommDlgExtendedError() != 0)
						MessageBox(AfxGetMainWnd()->GetSafeHwnd(),"Error Selecting Backup File","Error", MB_OK);
					
					return FALSE;
				}
				m_strBackupPath = strFile;
			}
			else if(nMsgBoxResult == IDCANCEL)
			{
				//Cancel the Operation
				return FALSE;
			}
		}

		try
		{
			if(nMsgBoxResult != IDNO)
			{
				DeleteFile(m_strBackupPath);

				if(!MoveFile(RealFilePath,m_strBackupPath))
				{
					AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
				}
			}

			m_bBackupCreated = TRUE;
		}
		catch(CFileException *ex)
		{
			LPSTR MessageBuffer;
			DWORD dwBufferLength;
			DWORD dwFormatFlags = FORMAT_MESSAGE_ALLOCATE_BUFFER |
								  FORMAT_MESSAGE_IGNORE_INSERTS |
								  FORMAT_MESSAGE_FROM_SYSTEM;

			DWORD dwLastError = GetLastError();
			dwBufferLength = FormatMessageA(dwFormatFlags,NULL,dwLastError,
								MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
								(LPSTR) &MessageBuffer, 0, NULL);
			if(dwBufferLength > 0)
			{
				AfxMessageBox(MessageBuffer,MB_OK);
			}
			else
			{
				AfxMessageBox("Could not create a Backup.",MB_OK);
			}

			LocalFree( MessageBuffer );

			ex->Delete();

			return FALSE;
		}
	}
	return TRUE;
}

BOOL CTESFile::UpdateEntry(CTESEntry *UpdateEntry, 
						   const CStringArray *SubID,
						   const CStringArray *SubData,
						   BOOL SilentMode)
{
	ULONG cPath, nCutPosition, nStartPosition;
	ULONG nReadSize, nLen;
	DWORD nBytesRead,nBytesWritten;
	CHAR * lpBuffer;
	HANDLE hTempFile;
	CString TempPath;
	CString RealFilePath;
	CString EntryDataBuf;
	CString strLength;
	CTESEntry *TempEntry;
	FILETIME ftCreate, ftAccess, ftWrite;


	cPath = GetTempPath(1000,TempPath.GetBuffer(MAX_PATH));
	
	if(cPath == 0)
	{
		return FALSE;
	}
	
	TempPath.ReleaseBuffer(cPath);
	
	if(TempPath.Right(1) != "\\" && TempPath.Right(1) != "/")
	{
		TempPath += "\\";
	}

	TempPath += *(CString*)m_EntryMap["FILE"];
	TempPath.FreeExtra();

	RealFilePath = *(CString*)m_EntryMap["PATH"] + *(CString*)m_EntryMap["FILE"];



	nStartPosition = UpdateEntry->EntryStartPos;

	// ---Adjust Start Position if Necessary---

	int i,j;

	for(i = 0;i < m_aDeletedEntries.GetSize(); i++)
	{	// Adjust for Deleted Entries
		TempEntry = (CTESEntry*) m_aDeletedEntries.GetAt(i);
		if(TempEntry->EntryStartPos < UpdateEntry->EntryStartPos)
		{	//Deleted Entry was before current Entry
			nStartPosition -= TempEntry->EntrySize;
		}
	}

	for(j = 0;j < m_aUpdatedEntries.GetSize(); j++)
	{	// Adjust for Modified Entries
		TempEntry = (CTESEntry*) m_aUpdatedEntries.GetAt(j);
		if(TempEntry->EntryStartPos < UpdateEntry->EntryStartPos)
		{	//Deleted Entry was before current Entry
			nStartPosition += TempEntry->EntrySizeChange;
		}
	}

	// Build the New Entry Data
	EntryDataBuf.Empty();
	for(i = 0; i < SubID->GetSize(); i++)
	{
		nLen = SubData->GetAt(i).GetLength();
		strLength.Empty();
		strLength.Insert(0,(UCHAR) nLen);
		nLen = nLen >> 8;
		strLength.Insert(1,(UCHAR) nLen);
		nLen = nLen >> 8;
		strLength.Insert(2,(UCHAR) nLen);
		nLen = nLen >> 8;
		strLength.Insert(3,(UCHAR) nLen);
		
		EntryDataBuf += SubID->GetAt(i);
		EntryDataBuf += strLength;
		EntryDataBuf += SubData->GetAt(i);
	}

	// Check to see if the Entry Data has Changed
	if(EqualCStringBuffers(EntryDataBuf,UpdateEntry->EntryData))
	{
		// Updating Not Necessary
		return FALSE;
	}

	// Create Copy of Real Esp File
	if(!CopyFile(RealFilePath,TempPath,FALSE))
	{
		return FALSE;
	}

	hTempFile = CreateFile(TempPath,GENERIC_READ | GENERIC_WRITE,FILE_SHARE_WRITE | FILE_SHARE_READ,
				NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH,
				NULL);

	if(hTempFile == INVALID_HANDLE_VALUE)
	{
		DeleteFile(TempPath);
		return FALSE;
	}
	else
	{	// Get File Times to Restore Later
		GetFileTime(hTempFile, &ftCreate, &ftAccess, &ftWrite);
	}

	// Get Position After Entry to Cut Data From
	nCutPosition =  nStartPosition + UpdateEntry->EntrySize + UpdateEntry->EntrySizeChange;

	//Set Pointer Position to Entry to be updated
	if(SetFilePointer(hTempFile,nCutPosition,NULL,FILE_BEGIN) <= 0) 
	{
		CloseHandle(hTempFile);
		DeleteFile(TempPath);
		return FALSE;
	}

	// Calculate New Entry Size
	nLen = UpdateEntry->EntrySize + UpdateEntry->EntrySizeChange - 16 + 
			EntryDataBuf.GetLength() - UpdateEntry->EntryData.GetLength();
	strLength.Empty();
	strLength.Insert(0,(UCHAR) nLen);
	nLen = nLen >> 8;
	strLength.Insert(1,(UCHAR) nLen);
	nLen = nLen >> 8;
	strLength.Insert(2,(UCHAR) nLen);
	nLen = nLen >> 8;
	strLength.Insert(3,(UCHAR) nLen);


	nReadSize = GetFileSize(hTempFile,NULL);
	nReadSize -= nCutPosition;

	lpBuffer = new char[nReadSize + 1];

	TRY
	{

		// Read the Data After Entry In order to move it later
		if(!ReadFile(hTempFile,lpBuffer,nReadSize,&nBytesRead,NULL))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		if(nReadSize != nBytesRead)
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		// Point to Entry Start Location
		if(SetFilePointer(hTempFile,nStartPosition + 4,NULL,FILE_BEGIN) < 0)
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		// Write New Entry Length
		if(!WriteFile(hTempFile,strLength,4,&nBytesWritten,NULL))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		if(nBytesWritten != 4)
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		// Adjust Position to Start of Actual Data to Replace
		nStartPosition += (UpdateEntry->EntrySize + UpdateEntry->EntrySizeChange) - UpdateEntry->EntryData.GetLength();

		// Point to Entry Data Location
		if(SetFilePointer(hTempFile,nStartPosition,NULL,FILE_BEGIN) < 0)
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}
		// Write New Entry Data
		if(!WriteFile(hTempFile,EntryDataBuf,EntryDataBuf.GetLength(),&nBytesWritten,NULL))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		if(nBytesWritten != (ULONG) EntryDataBuf.GetLength())
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		// Write Back Data After Entry
		if(!WriteFile(hTempFile,lpBuffer,nBytesRead,&nBytesWritten,NULL))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		if(nBytesRead != nBytesWritten)
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		// Set the Current Location as the End of the File
		if(!SetEndOfFile(hTempFile))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}
		
		// Restore File Times
		if(!SetFileTime(hTempFile, &ftCreate, &ftAccess, &ftWrite))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		if(!CloseHandle(hTempFile))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}
		hTempFile = NULL;

		// Create The Backup
		if(!CreateBackupFile(RealFilePath, SilentMode))
		{
			// Exit Normally due to Cancel
			DeleteFile(TempPath);
			delete [] lpBuffer;
			return FALSE;
		}

		// Delete the RealFile if Still Present... Unnecessary
		DeleteFile(RealFilePath);
		
		//if(!MoveFileEx(TempPath,RealFilePath,MOVEFILE_REPLACE_EXISTING)) // Taken out: Not supported in Win95-ME

		// Move Temp File to Real File Position
		if(!MoveFile(TempPath,RealFilePath))
		{
			MessageBox(AfxGetMainWnd()->GetSafeHwnd(),"Esp may be lost, restore from generated Backup.",
									"Critical Error",MB_OK | MB_ICONSTOP);
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		UpdateEntry->EntrySizeChange += EntryDataBuf.GetLength() - UpdateEntry->EntryData.GetLength();
		UpdateEntry->EntryData = EntryDataBuf;

		// Search for Entry already existing in Array and Remove
		for(j = 0;j < m_aUpdatedEntries.GetSize(); j++)
		{	// Adjust for Modified Entries
			TempEntry = (CTESEntry*) m_aUpdatedEntries.GetAt(j);
			if(TempEntry->EntryName == UpdateEntry->EntryName)
			{	//Deleted Entry was before current Entry
				m_aUpdatedEntries.RemoveAt(j);
				break;
			}
		}
		// Add to Updated Entry Array
		m_aUpdatedEntries.Add(UpdateEntry);

	}
	CATCH(CFileException, pEx)
	{
		LPSTR MessageBuffer;
		DWORD dwBufferLength;
		DWORD dwFormatFlags = FORMAT_MESSAGE_ALLOCATE_BUFFER |
							  FORMAT_MESSAGE_IGNORE_INSERTS |
							  FORMAT_MESSAGE_FROM_SYSTEM;
		if(hTempFile)
		{
			CloseHandle(hTempFile);
		}
		DeleteFile(TempPath);
		
		delete [] lpBuffer;

		DWORD dwLastError = GetLastError();

		dwBufferLength = FormatMessageA(dwFormatFlags,NULL,dwLastError,
							MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
							(LPSTR) &MessageBuffer, 0, NULL);

		if(dwBufferLength > 0)
		{
			AfxMessageBox(MessageBuffer,MB_OK | MB_ICONSTOP);
		}
		else
		{
			AfxMessageBox("Could not update this Entry.",MB_OK | MB_ICONSTOP);
		}

		LocalFree( MessageBuffer );
		
		pEx->Delete();

		return FALSE;
	}
	END_CATCH

	delete [] lpBuffer;

	return TRUE;
}

BOOL CTESFile::DeleteEntry(const CTESEntry EntrytoDelete, const BOOL SilentMode)
{
	CString TempPath;
	CString RealFilePath;
	ULONG cPath, nCutPosition, nStartPosition;
	ULONG nReadSize;
	DWORD nBytesRead,nBytesWritten;
	CHAR * lpBuffer;
	HANDLE hTempFile;
	CTESEntry *TempEntry;
	FILETIME ftCreate, ftAccess, ftWrite;

	cPath = GetTempPath(1000,TempPath.GetBuffer(1000));
	if(cPath == 0)
	{
		return FALSE;
	}
	TempPath.ReleaseBuffer(cPath);
	
	if(TempPath.Right(1) != "\\" && TempPath.Right(1) != "/")
	{
		TempPath += "\\";
	}
	TempPath += *(CString*)m_EntryMap["FILE"];

	RealFilePath = *(CString*)m_EntryMap["PATH"] + *(CString*)m_EntryMap["FILE"];
	
	
	nStartPosition = EntrytoDelete.EntryStartPos;
	//Adjust Start Position if Necessary

	int i,j;

	for(i = 0;i < m_aDeletedEntries.GetSize(); i++)
	{
		TempEntry = (CTESEntry*) m_aDeletedEntries.GetAt(i);
		if(TempEntry->EntryStartPos < EntrytoDelete.EntryStartPos)
		{	//Deleted Entry was before current Entry
			nStartPosition -= TempEntry->EntrySize;
		}
	}

	for(j = 0;j < m_aUpdatedEntries.GetSize(); j++)
	{	// Adjust for Modified Entries
		TempEntry = (CTESEntry*) m_aUpdatedEntries.GetAt(j);
		if(TempEntry->EntryStartPos < EntrytoDelete.EntryStartPos)
		{	//Deleted Entry was before current Entry
			nStartPosition += TempEntry->EntrySizeChange;
		}
	}


	if(!CopyFile(RealFilePath,TempPath,FALSE))
	{
		return FALSE;
	}

	hTempFile = CreateFile(TempPath,GENERIC_READ | GENERIC_WRITE,FILE_SHARE_WRITE | FILE_SHARE_READ,
				NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH,
				NULL);

	if(hTempFile == INVALID_HANDLE_VALUE)
	{
		DeleteFile(TempPath);
		return FALSE;
	}
	else
	{	// Get File Times to Restore Later
		GetFileTime(hTempFile, &ftCreate, &ftAccess, &ftWrite);
	}

	// Get Position After Entry to Cut Data From
	nCutPosition =  nStartPosition + EntrytoDelete.EntrySize + EntrytoDelete.EntrySizeChange;
	
	//Set Pointer Position to Entry to be deleted
	if(SetFilePointer(hTempFile,nCutPosition,NULL,FILE_BEGIN) <= 0)
	{
		CloseHandle(hTempFile);
		DeleteFile(TempPath);
		return FALSE;
	}

	nReadSize = GetFileSize(hTempFile,NULL);
	nReadSize -= nCutPosition;

	lpBuffer = new char[nReadSize + 1];

	TRY
	{
		// Read the Data After Entry In order to move it later
		if(!ReadFile(hTempFile,lpBuffer,nReadSize,&nBytesRead,NULL))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		if(nReadSize != nBytesRead)
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		// Point to Entry Start Location
		if(SetFilePointer(hTempFile,nStartPosition,NULL,FILE_BEGIN) < 0)
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		// Write Back Data After Entry
		if(!WriteFile(hTempFile,lpBuffer,nBytesRead,&nBytesWritten,NULL))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		if(nBytesRead != nBytesWritten)
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		// Set the Current Location as the End of the File
		if(!SetEndOfFile(hTempFile))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		// Restore File Times
		if(!SetFileTime(hTempFile, &ftCreate, &ftAccess, &ftWrite))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}

		if(!CloseHandle(hTempFile))
		{
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}
		hTempFile = NULL;
		
		// Create The Backup
		if(!CreateBackupFile(RealFilePath, SilentMode))
		{
			// Exit Normally due to Cancel
			DeleteFile(TempPath);
			delete [] lpBuffer;
			return FALSE;
		}

		// Delete the RealFile if Still Present... Unnecessary
		DeleteFile(RealFilePath);

		//if(!MoveFileEx(TempPath,RealFilePath,MOVEFILE_REPLACE_EXISTING))

		// Move Temp File to Real File Position
		if(!MoveFile(TempPath,RealFilePath))
		{
			MessageBox(AfxGetMainWnd()->GetSafeHwnd(),"Esp may be lost, restore from generated Backup.","Critical Error",MB_OK | MB_ICONSTOP);
			AfxThrowFileException(CFileException::generic,ERROR_INVALID_DATA);
		}
	}
	CATCH(CFileException, pEx)
	{
		LPSTR MessageBuffer;
		DWORD dwBufferLength;
		DWORD dwFormatFlags = FORMAT_MESSAGE_ALLOCATE_BUFFER |
							  FORMAT_MESSAGE_IGNORE_INSERTS |
							  FORMAT_MESSAGE_FROM_SYSTEM;
		if(hTempFile)
		{
			CloseHandle(hTempFile);
		}
		DeleteFile(TempPath);
		
		delete [] lpBuffer;

		DWORD dwLastError = GetLastError();

		dwBufferLength = FormatMessageA(dwFormatFlags,NULL,dwLastError,
							MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
							(LPSTR) &MessageBuffer, 0, NULL);

		if(dwBufferLength > 0)
		{
			AfxMessageBox(MessageBuffer,MB_OK | MB_ICONSTOP);
		}
		else
		{
			AfxMessageBox("Could not delete this Entry.",MB_OK | MB_ICONSTOP);
		}

		LocalFree( MessageBuffer );
		
		pEx->Delete();

		return FALSE;
	}
	END_CATCH

	delete [] lpBuffer;

	return TRUE;
}

BOOL CTESFile::RemoveEntry(CTESEntry * EntrytoDelete,const CString ID)
{
	CPtrArray* pArray = ((CPtrArray*)m_EntryMap[ID]);
	int cArray = pArray->GetSize();
	for(int i = 0;i < cArray;i++)
	{
		//Compare Pointed Address Values
		if(((CTESEntry*)pArray->GetAt(i)) == EntrytoDelete)
		{
			//Add deleted entry to array for later deletion adjustments
			EntrytoDelete->EntrySizeChange = 0 - EntrytoDelete->EntrySize;
			m_aDeletedEntries.Add(pArray->GetAt(i));
			pArray->RemoveAt(i);

			return TRUE;
		}
	}
	return FALSE;
}

BOOL CTESFile::EqualCStringBuffers(CString str1, CString str2)
{	// Returns 0 if Equal
	int str1len = str1.GetLength();
	int str2len = str2.GetLength();

	if(str1len != str2len)
		return FALSE;

	for(int i = 0;i < str1len;i++)
	{
		if(str1[i] != str2[i])
			return FALSE;
	}

	return TRUE;
}
