// TESPCDView.cpp : implementation of the CWarningView class
//

#include "stdafx.h"
#include "tespcd.h"
#include "WarningView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWarningView

IMPLEMENT_DYNCREATE(CWarningView, CView)

BEGIN_MESSAGE_MAP(CWarningView, CView)
	//{{AFX_MSG_MAP(CWarningView)
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_NOTIFY(NM_DBLCLK,ID_WARNGRID, OnDblClick)
	ON_NOTIFY(NM_CHAR,ID_WARNGRID, OnKeyUp)
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWarningView construction/destruction

CWarningView::CWarningView()
{

}

CWarningView::~CWarningView()
{

}

/////////////////////////////////////////////////////////////////////////////
// CWarningView diagnostics

#ifdef _DEBUG
void CWarningView::AssertValid() const
{
	CView::AssertValid();
}

void CWarningView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWarningView message handlers

void CWarningView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	if (m_pGridCtrl == NULL)
	{
		// Create the Gridctrl object
		m_pGridCtrl = new CGridCtrl;
		if (!m_pGridCtrl) return;

		// Create the Gridctrl window
		CRect rect;
		GetClientRect(rect);
		m_pGridCtrl->Create(rect, this, ID_WARNGRID);

		// fill it up with stuff
		m_pGridCtrl->SetEditable(FALSE);
		m_pGridCtrl->EnableDragAndDrop(FALSE);

		try {
			m_pGridCtrl->SetRowCount(1);
			m_pGridCtrl->SetColumnCount(5);
			m_pGridCtrl->SetFixedRowCount(1);
			m_pGridCtrl->SetFixedColumnCount(0);
		}
		catch (CMemoryException* e)
		{
			e->ReportError();
			e->Delete();
			return;
		}

		
		GV_ITEM Item;
		Item.mask = GVIF_TEXT|GVIF_FORMAT;
		Item.row = 0;
		Item.nFormat = DT_CENTER|DT_WORDBREAK;
		Item.col = 0;
		m_pGridCtrl->SetColumnWidth(0,50);
		Item.strText = _T("ID");
		m_pGridCtrl->SetItem(&Item);
		Item.col = 1;
		m_pGridCtrl->SetColumnWidth(1,300);
		Item.strText = _T("Warning");
		m_pGridCtrl->SetItem(&Item);
		Item.col = 2;
		m_pGridCtrl->SetColumnWidth(2,150);
		Item.strText = _T("Name");
		m_pGridCtrl->SetItem(&Item);
		Item.col = 3;
		m_pGridCtrl->SetColumnWidth(3,150);
		Item.strText = _T("Esp File");
		m_pGridCtrl->SetItem(&Item);
		Item.col = 4;
		m_pGridCtrl->SetColumnWidth(4,100);
		Item.strText = _T("Original File");
		m_pGridCtrl->SetItem(&Item);

		m_pGridCtrl->SetHeaderSort(true);

	}
}

void CWarningView::OnDblClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int nOtherCol;
	bool bEsmType = false;
	CTESEntry * pNewEntry, * pOtherEntry;
	unsigned char * pNewBuffer, * pOtherBuffer;
	int	NewBufferLength, OtherBufferLength;
	CTESFile *pEspFile;
	CStringArray *SubID, *SubData;
	
	CString cellFilename = m_pGridCtrl->GetItemText(((NM_GRIDVIEW*)pNMHDR)->iRow,((NM_GRIDVIEW*)pNMHDR)->iColumn);
	CString cellID = m_pGridCtrl->GetItemText(((NM_GRIDVIEW*)pNMHDR)->iRow,0);
	CString cellName = m_pGridCtrl->GetItemText(((NM_GRIDVIEW*)pNMHDR)->iRow,2);
	
	CTESPCDDoc* pDoc = GetDocument();

	bEsmType = (((NM_GRIDVIEW*)pNMHDR)->iColumn == 4);

	if(((NM_GRIDVIEW*)pNMHDR)->iColumn == 3)
		nOtherCol = 4;
	else if(((NM_GRIDVIEW*)pNMHDR)->iColumn == 4)
		nOtherCol = 3;
	else
		nOtherCol = 3;

	CString otherFilename = m_pGridCtrl->GetItemText(((NM_GRIDVIEW*)pNMHDR)->iRow,nOtherCol);

	if(pDoc->GetEntry(cellFilename,cellName,cellID,pNewEntry,!bEsmType))
	{
		NewBufferLength = pNewEntry->EntryData.GetLength();
		pNewBuffer = (unsigned char*)pNewEntry->EntryData.GetBuffer(0);
		pNewEntry->EntryData.ReleaseBuffer(NewBufferLength);

		if(pDoc->GetEntry(otherFilename,cellName,cellID,pOtherEntry,bEsmType))
		{
			OtherBufferLength = pOtherEntry->EntryData.GetLength();
			pOtherBuffer = (unsigned char*)pOtherEntry->EntryData.GetBuffer(0);
			pOtherEntry->EntryData.ReleaseBuffer(OtherBufferLength);
		}
		else
		{
			OtherBufferLength = NewBufferLength;
			pOtherBuffer = pNewBuffer;
		}

		if(((CMainFrame*)AfxGetMainWnd())->FocusPopup(cellFilename + " - " + cellName))
		{
			*pResult = 0;
			return;
		}

		CEntryDlg* pEntryDlg = new CEntryDlg(cellID,cellName,cellFilename);

		pDoc->GetTesFileObj(cellFilename,pEspFile,!bEsmType);
		SubID = new CStringArray(); // Deleted in EntryDlg
		SubData = new CStringArray(); // Deleted in EntryDlg
		pEspFile->ParseEntry(SubID, SubData, *pNewEntry);

		pEntryDlg->SetEsmMode(bEsmType);
		pEntryDlg->SetData(pNewBuffer, NewBufferLength,pOtherBuffer,OtherBufferLength,
							SubID, SubData);

		if(pEntryDlg->Create(IDD_ENTRYDLG,AfxGetMainWnd()))
		{
			pEntryDlg->SetWindowText(cellFilename + " - " + cellName);
			pEntryDlg->ShowWindow(SW_SHOW);
		}
		else
		{
			delete pEntryDlg;
			delete SubID;
			delete SubData;
		}
	}

	*pResult = 0;
}

void CWarningView::OnKeyUp(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if(((NM_GRIDVIEW*)pNMHDR)->param == VK_DELETE)
	{
		CString cellFilename;
		CString cellID;
		CString cellName;
		CStringArray delArrayFilename, delArrayID, delArrayName;
		int i = 0;

		CCellRange selectedRange = m_pGridCtrl->GetSelectedCellRange();
		int cSelectedRows = selectedRange.GetRowSpan();
		int curRow;
		BOOL ShowQuestion = true;

		CTESPCDDoc *pDoc = GetDocument();

		curRow = selectedRange.GetMaxRow();
		for(i = 0;i < cSelectedRows && curRow > 0;i++)
		{
			if(m_pGridCtrl->IsCellSelected(curRow,3))
			{
				cellFilename = m_pGridCtrl->GetItemText(curRow,3);
				cellID = m_pGridCtrl->GetItemText(curRow,0);
				cellName = m_pGridCtrl->GetItemText(curRow,2);

				((CMainFrame*)AfxGetMainWnd())->ClosePopup(cellFilename + " - " + cellName);

				if(pDoc->RemoveEspEntry(cellFilename, cellID, cellName, ShowQuestion))
				{
					delArrayFilename.Add(cellFilename);
					delArrayID.Add(cellID);
					delArrayName.Add(cellName);

					ShowQuestion = FALSE;
				}
			}

			curRow--;
		}

		for(curRow = 1;curRow < m_pGridCtrl->GetRowCount(); curRow++)
		{
			for(i = 0;i < delArrayFilename.GetSize();i++)
			{
				if(m_pGridCtrl->GetItemText(curRow,0) == delArrayID.GetAt(i) &&
				   m_pGridCtrl->GetItemText(curRow,2) == delArrayName.GetAt(i))
				{
					if(m_pGridCtrl->GetItemText(curRow,3) == delArrayFilename.GetAt(i))
					{
						m_pGridCtrl->DeleteRow(curRow);
						curRow--;
					}
				}
			}
		}

		m_pGridCtrl->Refresh();

		*pResult = 0;
	}
}
